package de.hdm_stuttgart.mi.sda1;

import com.querydsl.jpa.impl.JPAQueryFactory;
import de.hdm_stuttgart.mi.sda1.model.QStudyCourse;
import de.hdm_stuttgart.mi.sda1.model.StudyCourse;

import javax.persistence.*;

/**
 * Read a {@link StudyCourse} by its primary key value.
 */
public class QuerydslReadLikeCstudyCourses {

  static private final EntityManagerFactory factory = Persistence.createEntityManagerFactory(
    "strategy_none");

  static private final EntityManager entityManager = factory.createEntityManager();
  /**
   * @param args unused
   */
  public static void main( String[] args ) {

    final QStudyCourse qStudyCourse = QStudyCourse.studyCourse;
    final JPAQueryFactory queryFactory = new JPAQueryFactory(entityManager);

    queryFactory.
        selectFrom(qStudyCourse).
        fetch().
        stream().
        map(s -> "All: Read '" + s + "'").
        forEach(System.out::println);


    queryFactory.
        selectFrom(qStudyCourse).
        where(qStudyCourse.shortName.like("C%")).
        fetch().
        stream().
        map(s -> "Like C%: Read '" + s + "'").
        forEach(System.out::println);

    // See http://stackoverflow.com/questions/21645516/program-using-hibernate-does-not-terminate
    factory.close();
  }
}