package de.hdm_stuttgart.mi.sda1.model;

import javax.persistence.*;

@Entity
public class Student {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  Long id;

  @Column(length = 30, nullable = false, unique = true)
  private String name;

  @ManyToOne
  StudyCourse studyCourse;

  public void enroll(final StudyCourse studyCourse) {
    studyCourse.add(this);
    this.studyCourse = studyCourse;
  }

  protected Student() {}

  public Student(final String name) {
    this.name = name;
  }

  @Override
  public String toString() {
    return name +"(" + studyCourse + ")";
  }
}
