package de.hdm_stuttgart.mi.sda1.model;


import javax.persistence.*;
import java.util.List;
import java.util.Vector;

@Entity
public class StudyCourse {
  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  Long id;

  @Column(length = 3, nullable = false, unique = true)
  private String shortName;

  @Column(length = 150, nullable = false, unique = true)
  private String fullName;


  @OneToMany(mappedBy = "studyCourse", cascade = CascadeType.ALL)
  final List<Student> students = new Vector<>();

  protected StudyCourse(){}

  public StudyCourse(String shortName, String fullName) {
    this.shortName = shortName;
    this.fullName = fullName;
  }

  void add(final Student student) {
    students.add(student);
  }

  public void setFullName(final String fullName) {
    this.fullName = fullName;
  }
  @Override
  public String toString() {
    return fullName + "(" + shortName + ", id=" + id + ")";
  }
}