package de.hdm_stuttgart.mi.sd1.for2while;

public class Compute2 {

   /**
    * @param args Unused
    */
   public static void main(String[] args) {
      
      double ausgangskapital = 1000,
             gewuenschtesKapital = 1300,
             jahresZins = 1.8 /* in Prozent*/;
      
      System.out.format("Es braucht %d Jahre", anzahlJahre(ausgangskapital, gewuenschtesKapital, jahresZins));
      
   }
   
   /**
    * Wie viele Jahre dauert es, aus einem gegebenem Anfangskapital bei fester Verzinsung einen bestimmten Endbetrag zu erreichen?
    * 
    * Beispiel: Bei 1.8% jährlicher Verzinsung dauert es 15 Jahre, bis aus einem Ausgangskapital
    * von 1000.00 € durch Zinseszinsbildung erstmalig der Betrag von 1300.00€ erreicht bzw. überschritten wird.
    *  
    * @param ausgangsKapital
    * @param gewuenschtesEndkapital  Dieser Wert muss größer als das Ausgangskapital sein.
    * @param zinsatzJaehrlich  Die jährliche Verzinsung, z.B. 2.5%
    * @return Die Dauer in Jahren, bis das Endkapital erstmalig erreicht oder überschritten wird.
    * 
    */
   static public int anzahlJahre(double ausgangsKapital, final double gewuenschtesEndkapital, double zinsatzJaehrlich) {

      final double zinsfaktor = (1 + zinsatzJaehrlich / 100);
      
      int jahr = 0;
      for (; ausgangsKapital < gewuenschtesEndkapital; ausgangsKapital *= zinsfaktor) {
         jahr++;
      }
      return jahr;
   }
}
