package de.hdm_stuttgart.sw1.klausur.test;

import org.junit.Assert;
import org.junit.Test;
import org.junit.FixMethodOrder;
import org.junit.runners.MethodSorters;

import org.junit.Rule;
import org.junit.rules.DisableOnDebug;
import org.junit.rules.TestRule;
import org.junit.rules.Timeout;

import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.sw1.klausur.string.StringHelper;
import de.hdm_stuttgart.sw1.klausur.test.ignoriere_mich.Helper;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration", "javadoc"})
public class TestSummierteWortlaenge {

        @Rule // Kill test if lasting longer than 1000 milliseconds unless in debugging mode
        public final TestRule timeout = new DisableOnDebug(Timeout.millis(1000));

	@Test
	public void testNull() {
		Assert.assertEquals("Ein null String hat die Länge 0", 0,
				StringHelper.summierteWortLaenge(null));
	}

	@Test
   @Marking(points=5)
	public void summierteWortLaengeNonNull() {
		
		pruefeErwarteteLaenge(new String[] {}, 0);
		pruefeErwarteteLaenge(new String[] { "" }, 0);
		pruefeErwarteteLaenge(new String[] { "Einfach" }, 7);
		pruefeErwarteteLaenge(new String[] { "Einfach, ", ", doppelt" }, 18);
		pruefeErwarteteLaenge(new String[] { "Einfach, ", ", doppelt", ", dreifach" }, 28);
	}

	@Test
   @Marking(points=5)
	public void testMixedNull() {
		
		pruefeErwarteteLaenge(new String[] { null }, 0);
		pruefeErwarteteLaenge(new String[] { null, null }, 0);
		pruefeErwarteteLaenge(new String[] { "Einfach", null }, 7);
		pruefeErwarteteLaenge(new String[] { "Einfach, ", null, ", doppelt" }, 18);
		pruefeErwarteteLaenge(new String[] { null, "Einfach, ", null, ", doppelt"}, 18);
		pruefeErwarteteLaenge(new String[] { null, "Einfach, ", null, ", doppelt", ", dreifach", null }, 28);
		pruefeErwarteteLaenge(new String[] { "Dies", " ist ", " kurz.", null }, 15);
	}

	// Interne Hilfsmethode
	private static void pruefeErwarteteLaenge(final String[] s, int erwarteteLaenge) {
      Assert.assertEquals("Wortliste '" + Helper.toString(s) + "' hat erwartete Gesamtlänge " + erwarteteLaenge,
            erwarteteLaenge,
            StringHelper.summierteWortLaenge(s));
   }
   
}
