package de.hdm_stuttgart.sw1.klausur.test;

import org.junit.Assert;
import org.junit.Test;
import org.junit.Rule;
import org.junit.rules.DisableOnDebug;
import org.junit.rules.TestRule;
import org.junit.rules.Timeout;
import org.junit.FixMethodOrder;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.Marking;
import de.hdm_stuttgart.mi.exam.MarkingTest;
import de.hdm_stuttgart.sw1.klausur.string.StringHelper;

/**
 * String Tests.
 */
@SuppressWarnings({"UnusedDeclaration", "static-method", "javadoc"})
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class TestAnzahlZiffernStringArray  extends MarkingTest {

        @Rule // Kill test if lasting longer than 1000 milliseconds unless in debugging mode
        public final TestRule timeout = new DisableOnDebug(Timeout.millis(1000));
    
	private static void pruefeErwarteteZiffernAnzahl(final String s[], final int erwarteteZiffernzahl) {
		Assert.assertEquals(
				"String array " + Helper.toString(s) + " enthält " + erwarteteZiffernzahl + " Ziffern.",
				erwarteteZiffernzahl, 
				StringHelper.anzahlZiffern(s));
	}

	@Test
	public void testAnzahlZiffernNull() {
		final String t = null;
		Assert.assertEquals("Ein null String[] enthält 0 Ziffern",
				0,
				StringHelper.anzahlZiffern(t));
	}

	@Test
	@Marking(points=2)
	public void testAnzahlZiffernNotNull() {

		pruefeErwarteteZiffernAnzahl(new String[]{}, 0);
		pruefeErwarteteZiffernAnzahl(new String[]{""}, 0);
		pruefeErwarteteZiffernAnzahl(new String[]{"1", " and", "33 plus 4"}, 4);
	}

	@Test
	@Marking(points=2)
	public void testAnzahlZiffernMixedNull() {
		pruefeErwarteteZiffernAnzahl(new String[]{null}, 0);
		pruefeErwarteteZiffernAnzahl(new String[]{null, null}, 0);
		pruefeErwarteteZiffernAnzahl(new String[]{"1", null, " and", "337 plus 4", null, null}, 5);
	}
}
