package de.hdm_stuttgart.sw1.klausur;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

/**
 * Ersetzungen in Zeichenketten.
 *
 */
public class StringTransforms {
	private static Logger log = LogManager.getLogger(StringTransforms.class);

	/**
	 * Eine urbane Legende attestiert Chinesen das Problem der Aussprache des
	 * Buchstabens "r". Sie würden stattdessen ein "l" verwenden.
	 * 
	 * Die Methode ersetzt alle Buchstaben 'r' durch 'l' bzw. 'R' durch 'L'.
	 * 
	 * Beispiel:
	 * 
	 * Aus "Der arme Richard" wird "Del alme Lichald"
	 * 
	 * @param input
	 *  Eine beliebige, von null verschiedene Zeichenkette
	 *            
	 * @return
	 * 	Die Ersetzung der Zeichenkette gemäß {'r' zu 'l', 'R' zu 'L'}
	 */
	public static String chinesischerAkzent(final String input) {
		
		log.info("Bei Bedarf zur Fehlersuche logging Statements nutzen");

		return "Blödsinn";// TODO implementiere mich
	}

	/**
	 * Sprachwissenschaftler sind der Ansicht, dass auch nach dem Entfernen von
	 * Vokalen der Text lesbar bleibt. Beispiel: "Die Anden" wird zu "D ndn"
	 * 
	 * @param input
	 *            Eine beliebige Zeichenkette oder null
	 * 
	 * @return null, falls Eingabe null, sonst der Eingabestring ohne Vokale {aeiouAEIOU}
	 */
	public static String entferneVokale(final String input) {
		log.info("Bei Bedarf zur Fehlersuche logging Statements nutzen");

		return "Blödsinn";// TODO implement me
	}

	/**
	 * Umwandlung eines Wortes (ohne Leerzeichen) in Morsezeichen gemäß dem Morse Alphabet als
	 * Folge langer (-) und kurzer (.) durch Pausen (Leerzeichen) getrennter Töne:
	 * 
	 * 		A .-    D -..  G --.  J .--- M --
	 *		B -...  E .    H .... K -.-  N -.
	 *		C -.-.  F ..-. I ..   L .-.. 
	 *      Buchstaben O bis Z sowie Ziffern 0 bis 9 aus Platzgründen weggelassen. Diese brauchen
	 *      in der Klausur aus Zeitgründen nicht implementiert zu werden.
	 *  
	 *  Regeln:
	 *   -Kleinbuchstaben werden zunächst in Großbuchstaben umgewandelt
	 *   -Pro Buchstabe / Ziffer wird nach der Morse Zeichenfolge eine Pause (Leerzeichen) eingefügt.
	 *  
	 *  Beispiel (Leerzeichen beachten, auch am Ende des Morsecodes):
	 *   Aus "Abend" wird ".- -... . -. -.. "
	 * 
	 * @param input
	 * 		Das Klartextwort, welches durch Morsezeichen kodiert werden soll.
	 * @return
	 * 		Die Übersetzung in das Morsealphabet.
	 */
	public static String morsen(final String input) {

		log.info("Bei Bedarf zur Fehlersuche logging Statements nutzen");

		return "Blödsinn";// TODO implement me
	}

}
