package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe1.Vielfache;

/**
 * Testen von {@link Vielfache#istEchtesVielfachesVon(int, int)}
 *
 */
@SuppressWarnings({"UnusedDeclaration", "static-method"})
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_Vielfache extends ExaminationTestDefaults {
   /**
    * Positive echte Vielfache
    */
   @Test
   @Marking(points=2)
   public void test_300_positivIstVielfaches() {
      Assert.assertTrue(Vielfache.istEchtesVielfachesVon(6, 2));
      Assert.assertTrue(Vielfache.istEchtesVielfachesVon(3, 1));
   }
   /**
    * Negative echte Vielfache
    */
   @Test
   @Marking(points=2)
   public void test_310_negativIstVielfaches() {
      Assert.assertTrue(Vielfache.istEchtesVielfachesVon(-9, -3));
      Assert.assertTrue(Vielfache.istEchtesVielfachesVon(-7, -1));
   }

   /**
    * Positiv- / Negativwerte gemischt.
    */
   @Test
   @Marking(points=2)
   public void test_330_gemischtIstVielfaches() {
      Assert.assertTrue(Vielfache.istEchtesVielfachesVon(12, -4));
      Assert.assertTrue(Vielfache.istEchtesVielfachesVon(-18, 6));
      Assert.assertTrue(Vielfache.istEchtesVielfachesVon(-21, 1));
      Assert.assertTrue(Vielfache.istEchtesVielfachesVon(17, -1));
   }
   
   /**
    * Nicht-Vielfache positiv/positiv oder negativ/negativ
    */
   @Test
   public void test_340_positivKeinVielfaches() {
      Assert.assertFalse(Vielfache.istEchtesVielfachesVon(8, 3));
      Assert.assertFalse(Vielfache.istEchtesVielfachesVon(2, 7));
      Assert.assertFalse(Vielfache.istEchtesVielfachesVon(-8, -3));
      Assert.assertFalse(Vielfache.istEchtesVielfachesVon(-2, -7));
   }
   /**
    * Nicht-Vielfache gemischt.
    */
   @Test
   @Marking(points=2)
   public void test_350_gemischtKeinVielfaches() {
      Assert.assertFalse(Vielfache.istEchtesVielfachesVon(-8, 3));
      Assert.assertFalse(Vielfache.istEchtesVielfachesVon(-2, 5));
      Assert.assertFalse(Vielfache.istEchtesVielfachesVon(8, -3));
      Assert.assertFalse(Vielfache.istEchtesVielfachesVon(2, -5));
   }
   /**
    * Sonderfall 0 und 0.
    */
   @Test
   public void test_340_nullNullIstVielfaches() {
      Assert.assertTrue(Vielfache.istEchtesVielfachesVon(0, 0));
   }

   /**
    * Sonderfall ungleich 0 mit 0.
    */
   @Test
   public void test_350_ungleichNullUndNullKeinVielfaches() {
      Assert.assertFalse(Vielfache.istEchtesVielfachesVon(5, 0));
      Assert.assertFalse(Vielfache.istEchtesVielfachesVon(-7, 0));
   }
}
