package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe1.StringHaeufigkeiten;

/**
 * <p>Testen des Auftretens eines Teil-String in einem vorgegebenen String.</p>
 *
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration"})
public class Test_StringHaeufigkeiten extends ExaminationTestDefaults {
   
   /**
    * Dreifaches Auftreten von "in" im String "in innerer Windeseile"
    */
   @Test
   @Marking(points=3)
   public void test_200() {
      Assert.assertEquals(
            3,                           
            StringHaeufigkeiten.getAnzahlAuftreten("in innerer Windeseile", "in"));
   }
   /**
    * Einfaches Auftreten von "aua" im String "auaua"
    */
   @Test
   @Marking(points=2)
   public void test_220() {
      Assert.assertEquals(
            1,                           
            StringHaeufigkeiten.getAnzahlAuftreten("auaua", "aua"));
   }
   /**
    * "aua" tritt in "auaua" einmal (überlappungsfrei) auf.
    */
   @Test
   @Marking(points=2)
   public void test_240() {
      Assert.assertEquals(
            1,                           
            StringHaeufigkeiten.getAnzahlAuftreten("auaua", "aua"));
   }
   /**
    * 
    */
   @Test
   @Marking(points=1)
   public void test_260() {
      Assert.assertEquals(
            0,                           
            StringHaeufigkeiten.getAnzahlAuftreten("", "aua"));
   }
   /**
    * 
    */
   @Test
   @Marking(points=1)
   public void test_280() {
      Assert.assertEquals(
            0,                           
            StringHaeufigkeiten.getAnzahlAuftreten("abcdefghi", "uups"));
   }
   /**
    * 
    */
   @Test
   @Marking(points=1)
   public void test_300() {
      Assert.assertEquals(
            1,                           
            StringHaeufigkeiten.getAnzahlAuftreten("tim", "tim"));
   }
}
