package de.hdm_stuttgart.mi.sd1.aufgabe2;

/**
 * <p>Ersatzteile.</p>
 *    
 */
public class Ersatzteil {
	private int teilenummer;
	private String bezeichnung;
	
	/**
	 * Neues Ersatzteil mit Teilenummer und informeller Bezeichnung
	 * 
	 * @param teilenummer Eindeutige Nummer des Ersatzteils
	 * @param bezeichnung Bezeichnung des Ersatzteils, z.B. »Schraube M8«
	 */
	public Ersatzteil(final int teilenummer, final String bezeichnung) {
		this.teilenummer = teilenummer;
		this.bezeichnung = bezeichnung;
	}

	@Override
	public final boolean equals(Object obj) {
		
		if (obj instanceof Ersatzteil) {
			return ((Ersatzteil) obj).teilenummer == teilenummer;
		} else {
			return false;
		}
	}

	@Override
	public String toString() {
		return (null == bezeichnung? "Bezeichnung unbekannt" :  bezeichnung) + ", Teilenummer:" + teilenummer;
	}
}