package de.hdm_stuttgart.mi.sd1.aufgabe2;

import de.hdm_stuttgart.mi.sd1.aufgabe1.Maexchen;

/**
 * <p>Darstellung eines Mäxchen Wurfs, z.B. (3|2), siehe auch die Erläuterungen in {@link Maexchen}.</p>
 *
 * <object data="../aufgabe1/doc-files/maexle.png" type="image/png"></object>
 */
public class MaexleWurf {

  /**
   * Ein Wurf bestehend aus den Augenzahlen beider Würfel. Die Reihenfolge der Augenzahlen spielt dabei keine Rolle.
   *
   * @param wuerfel1 Augenzahl des ersten Würfels.
   * @param wuerfel2 Augenzahl des zweiten Würfels.
   */
  public MaexleWurf(final int wuerfel1, final int wuerfel2) {
    // TODO: Implementiere mich richtig!
  }

  /**
   * <p>Vergleiche den aktuellen Wurf mit einem anderen Wurf: Welches Paar von Augenzahlen liegt höher? Nachfolgend
   * die Werte in aufsteigender Reihenfolge:</p>
   *
   * <table class="goikTableDefaults">
   *   <tr>
   *     <th >Typ</th>
   *     <th >Würfe aufsteigend</th>
   *   </tr>
   *
   *   <tr>
   *     <td rowspan="4" style='vertical-align: top;'>Standard</td>
   *     <td>(3|1) (3|2)</td>
   *   </tr>
   *
   *   <tr>
   *     <td>(4|1) (4|2) (4|3)</td>
   *   </tr>
   *
   *   <tr>
   *     <td>(5|1) (5|2) (5|3) (5|4)</td>
   *   </tr>
   *
   *   <tr>
   *     <td>(6|1) (6|2) (6|3) (6|4) (6|5)</td>
   *   </tr>
   *
   *   <tr>
   *     <td style='vertical-align: top;'>Pasch</td>
   *     <td>(1|1) (2|2) (3|3) (4|4) (5|5) (6|6)</td>
   *   </tr>
   *
   *   <tr>
   *     <td style='vertical-align: top;'>Mäxle</td>
   *     <td>(2|1)</td>
   *   </tr>
   *
   *   <caption>Reihenfolge gewürfelter Augenpaare in aufsteigender Folge im Mäxle Spiel.</caption>
   * </table>
   *
   * <p>Damit ergibt sich die Reihenfolge gewürfelter Werte zu:</p>
   *
   * <pre>31, 32, 41, 42, 43, 51, 52, 53, 54, 61, 62, 63, 64, 65, 11, 22, 33, 44, 55, 66, 21</pre>
   *
   * <p>Beispiele:</p>
   *
   * <ul>
   *   <li><code>(2|5)</code> wird »52« gesprochen und ist gleichwertig zu <code>(5|2)</code>. Dieser Wurf liegt über
   *   z.B. (4|3) bzw. (3|4), gesprochen »43«</li>
   *
   *   <li><code>(2|2)</code> ist als höher als alle nicht- Pasch/Mäxle Werte wie z.B. <code>(6|5)</code>,
   *   aber niedriger als das Mäxchen <code>(2|1)</code>.</li>
   *
   * </ul>
   *
   * @param anderer Ein im Spiel geworfener Wert bestehend aus den Augenzahlen zweier Würfel.
   *
   * @return <ul>
   *   <li>positives Ergebnis, falls fremder Wert höher liegt.</li>
   *   <li>0, falls Wert gleich ist</li>
   *   <li>negatives Ergebnis, falls fremder Wert niedriger liegt.</li>
   * </ul>
   */
  public int compareTo(final MaexleWurf anderer) {
    return -12345; // TODO: Implementiere mich richtig!
  }
}