package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe1.Helper;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration"})
public class Test_Helper extends ExaminationTestDefaults {

  /**
   * Nicht bestanden.
   */
  @Test @Marking(points = 2) public void test_410() {
    Assert.assertEquals("mangelhaft", Helper.berechneNote(-100));
    Assert.assertEquals("mangelhaft", Helper.berechneNote(0));
    Assert.assertEquals("mangelhaft", Helper.berechneNote(49));

  }

  /**
   * Ausreichend.
   */
  @Test @Marking(points = 2) public void test_430() {
    Assert.assertEquals("ausreichend", Helper.berechneNote(50));
    Assert.assertEquals("ausreichend", Helper.berechneNote(51));
    Assert.assertEquals("ausreichend", Helper.berechneNote(61));
    Assert.assertEquals("ausreichend", Helper.berechneNote(64));



  }

  /**
   * .
   */
  @Test @Marking(points = 2) public void test_450() {
    Assert.assertEquals("befriedigend", Helper.berechneNote(65));
    Assert.assertEquals("befriedigend", Helper.berechneNote(66));
    Assert.assertEquals("befriedigend", Helper.berechneNote(75));
    Assert.assertEquals("befriedigend", Helper.berechneNote(79));
  }

  /**
   * .
   */
  @Test @Marking(points = 2) public void test_460() {
    Assert.assertEquals("gut", Helper.berechneNote(80));
    Assert.assertEquals("gut", Helper.berechneNote(81));
    Assert.assertEquals("gut", Helper.berechneNote(85));
    Assert.assertEquals("gut", Helper.berechneNote(90));
    Assert.assertEquals("gut", Helper.berechneNote(94));
  }

  /**
   * .
   */
  @Test @Marking(points = 2) public void test_470() {
    Assert.assertEquals("sehr gut", Helper.berechneNote(95));
    Assert.assertEquals("sehr gut", Helper.berechneNote(99));
    Assert.assertEquals("sehr gut", Helper.berechneNote(100));
    Assert.assertEquals("sehr gut", Helper.berechneNote(200));
  }

/******************************************************************
 * Abschnitt Umwandlung jedes Wortanfangs in einen Großbuchstaben *
 ******************************************************************/

  /**
   * Sonderfall null.
   */
  @Test @Marking(points = 2) public void test_500() {
    Assert.assertEquals(null, Helper.getWortanfangGross(null));
  }
  /**
   * Sonderfall leer.
   */
  @Test @Marking(points = 2) public void test_510() {
    Assert.assertEquals("", Helper.getWortanfangGross(""));
  }
  /**
   * Nur ein Zeichen
   */
  @Test @Marking(points = 2) public void test_520() {
    Assert.assertEquals("A", Helper.getWortanfangGross("a"));
  }
  /**
   * Nur ein Zeichen, unverändert
   */
  @Test @Marking(points = 2) public void test_540() {
    Assert.assertEquals("A", Helper.getWortanfangGross("a"));
  }
  /**
   * Regulärer Satz.
   */
  @Test @Marking(points = 2) public void test_560() {
    Assert.assertEquals(     "Ein Schöner Warmer Sommer Steht An.",
      Helper.getWortanfangGross("Ein schöner warmer Sommer steht an."));
  }
  /**
   * Regulärer Satz, mehrere Leerzeichen in Folge
   */
  @Test @Marking(points = 2) public void test_580() {
    Assert.assertEquals(     "Hier   Ist  Mehr     Platz",
      Helper.getWortanfangGross("Hier   ist  mehr     Platz"));
  }

  /******************************************
   * Abschnitt vertauschen von Array Werten *
   ******************************************/

  @Test public void test_600() {
    final int[] input = null;
    Assert.assertFalse(Helper.swap(null, 0));
  }

  @Test public void test_620() {
    final int[] input = {2, 5, 6};
    Assert.assertFalse(Helper.swap(input, 2));
    Assert.assertArrayEquals(new int[]{2, 5, 6}, input);

    Assert.assertFalse(Helper.swap(input, 3));
    Assert.assertArrayEquals(new int[]{2, 5, 6}, input);

    Assert.assertFalse(Helper.swap(input, 4));
    Assert.assertArrayEquals(new int[]{2, 5, 6}, input);
  }
  @Test public void test_640() {
    final int[] input = {-1, 3, 4};
    Assert.assertFalse(Helper.swap(input, -1));
    Assert.assertArrayEquals(new int[]{-1, 3 , 4}, input);

    Assert.assertFalse(Helper.swap(input, -2));
    Assert.assertArrayEquals(new int[]{-1, 3 , 4}, input);
  }

  @Test public void test_660() {
    final int[] input = {-1};
    Assert.assertFalse(Helper.swap(input, 0));
    Assert.assertArrayEquals(new int[]{-1}, input);

    Assert.assertFalse(Helper.swap(input, -2));
    Assert.assertArrayEquals(new int[]{-1
    }, input);
  }

  @Test public void test_680() {
    final int[] input = {-1, -2};
    Assert.assertTrue(Helper.swap(input, 0));
    Assert.assertArrayEquals(new int[]{-2, -1}, input);
  }

  @Test public void test_690() {
    final int[] input = {2, 5, 6};
    Assert.assertTrue(Helper.swap(input, 1));
    Assert.assertArrayEquals(new int[]{2, 6, 5}, input);
  }

  /******************************
   * Abschnitt Dezimalzerlegung *
   ******************************/
  @Test public void test_700() {
    Assert.assertArrayEquals(new long[]{0}, Helper.dezimalZerlegung(0));
  }
  @Test public void test_720() {
    Assert.assertArrayEquals(new long[]{1}, Helper.dezimalZerlegung(1));
    Assert.assertArrayEquals(new long[]{2}, Helper.dezimalZerlegung(2));
    Assert.assertArrayEquals(new long[]{3}, Helper.dezimalZerlegung(3));
    Assert.assertArrayEquals(new long[]{7}, Helper.dezimalZerlegung(7));
  }
  @Test public void test_740() {
    Assert.assertArrayEquals(new long[]{0, 10}, Helper.dezimalZerlegung(10));
    Assert.assertArrayEquals(new long[]{1, 10}, Helper.dezimalZerlegung(11));
    Assert.assertArrayEquals(new long[]{9, 30}, Helper.dezimalZerlegung(39));
    Assert.assertArrayEquals(new long[]{7, 90}, Helper.dezimalZerlegung(97));
  }
  @Test public void test_760() {
    Assert.assertArrayEquals(new long[]{0,  0, 700}, Helper.dezimalZerlegung(700));
    Assert.assertArrayEquals(new long[]{1,  0, 700}, Helper.dezimalZerlegung(701));
    Assert.assertArrayEquals(new long[]{0, 10, 700}, Helper.dezimalZerlegung(710));
    Assert.assertArrayEquals(new long[]{1, 10, 700}, Helper.dezimalZerlegung(711));
    Assert.assertArrayEquals(new long[]{9, 90, 900}, Helper.dezimalZerlegung(999));
  }
  @Test public void test_780() {
    Assert.assertArrayEquals(new long[]{
      7,
      0,
      800,
      5000,

      70000,
      700000,
      4000000,
      50000000,

      800000000,
      6000000000L,
      30000000000L,
      0,

      2000000000000L,
      70000000000000L,
      300000000000000L,
      3000000000000000L,

      20000000000000000L,
      200000000000000000L,
      9000000000000000000L,
    }, Helper.dezimalZerlegung(922_3372_0368_5477_5807L));
  }
}
