package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe1.FitnessTarifRechner;
import de.hdm_stuttgart.mi.sd1.aufgabe1.Maexchen;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

/**
 * <p>Mäxchen spielen.</p>
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration"})
public class Test_Maexchen extends ExaminationTestDefaults {

  /**
   * Pasch.
   */
  @Test public void test_200() {
    for (int i = 1; i <= 6; i++) {
      Assert.assertTrue(Maexchen.istPasch(i, i));
    }
    Assert.assertFalse(Maexchen.istPasch(1, 2));

  }
  /**
   * Kein Pasch.
   */
  @Test public void test_220() {
    Assert.assertTrue(Maexchen.istPasch(3, 3));
    for (int i = 1; i <= 6; i++) {
      for (int j = 1; j < i; j++) {
        Assert.assertFalse(Maexchen.istPasch(i, j));
        Assert.assertFalse(Maexchen.istPasch(j, i));
      }
    }
  }
  /**
   * Mäxchen.
   */
  @Test public void test_240() {
    Assert.assertTrue(Maexchen.istMaexchen(1, 2));
    Assert.assertFalse(Maexchen.istMaexchen(5, 5));
    Assert.assertFalse(Maexchen.istMaexchen(4, 1));
  }
  /**
   * Mäxchen, umgekehrt.
   */
  @Test public void test_260() {
    Assert.assertTrue(Maexchen.istMaexchen(2, 1));
    Assert.assertFalse(Maexchen.istMaexchen(3, 3));
    Assert.assertFalse(Maexchen.istMaexchen(2, 6));
  }
  /**
   * Kein Sonderfall.
   */
  @Test public void test_280() {
    for (int i = 1; i <= 6; i++) {
      for (int j = 1; j < 6; j++) {
        if ( i != j && // Kein »Pasch«
            (i != 1 || j != 2) && (i != 2 || j != 1) // Kein »Mäxchen«
          )
           {
          Assert.assertTrue(Maexchen.istKeinSonderfall(i, j));
        }
      }
    }
  }
}
