package de.hdm_stuttgart.mi.sd1.test.helper;

import java.lang.reflect.Constructor;

public class ReflectConstructor<T> {
	
	public ReflectConstructor(final ReflectClass<T> reflectClass, final Class<?>[] argumentMeta) {
		this.definingClass = reflectClass;
		Constructor<?> constructorTmp = null;
		String tmpMsg = null;
		if (null == reflectClass.classZ) {
			tmpMsg = "Folgefehler: Klasse '" + reflectClass.className + "' nicht definiert"; 
		} else {
		try {
			constructorTmp = reflectClass.classZ.getConstructor(argumentMeta);
		} catch (final NoSuchMethodException | SecurityException e) {
			tmpMsg = "Kein Konstruktor '" +
						reflectClass.classZ.getSimpleName() + "(" +
						ReflectClass.formatArguments(argumentMeta) +
						")' in Klasse '" + 
						reflectClass.className + "' gefunden";
		}
		}
		constructor = (Constructor<T>) constructorTmp;
		msg = tmpMsg;
	}
	public String getRecursiveMsg() {
		if (null == definingClass.msg) {
			return msg;
		} else {
			return "Folgefehler: " + definingClass.msg;
		}
	}
	
	public final ReflectClass<T> definingClass;
	public final Constructor<T> constructor;
	private final String msg;
}