package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe1.MathHelper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration"})
public class Test_MathHelper extends ExaminationTestDefaults {
  /**
   * Zwei gerade Werte.
   */
  @Test @Marking(points = 4) public void test_100_nullUngeradeWerte() {
    Assert.assertEquals(0, MathHelper.summeUngeraderWerte(224, -418));
    Assert.assertEquals(0, MathHelper.summeUngeraderWerte(-418, 224));
  }
  /**
   * Gerade und ungerade gemischt.
   */
  @Test @Marking(points = 4) public void test_110_einUngeraderWert() {
    Assert.assertEquals(-419, MathHelper.summeUngeraderWerte(224, -419));
    Assert.assertEquals(-3, MathHelper.summeUngeraderWerte(-3, 224));
  }
  /**
   * Zwei ungerade Werte.
   */
  @Test @Marking(points = 4) public void test_120_zweiUngeradeWerte() {
    Assert.assertEquals(-14, MathHelper.summeUngeraderWerte(-17, 3));
    Assert.assertEquals(-4, MathHelper.summeUngeraderWerte(3, -7));
  }

  @Test @Marking(points = 3) public void test_200_testHarmonisch() {
    Assert.assertEquals(1.,                 MathHelper.harmonisch(1),    1.E-14);
  }
  @Test @Marking(points = 3) public void test_210_testHarmonisch() {
    Assert.assertEquals(1.5,                MathHelper.harmonisch(2),    1.E-14);
    Assert.assertEquals(1.8333333333333333, MathHelper.harmonisch(3),    1.E-14);

    Assert.assertEquals(2.9289682539682538, MathHelper.harmonisch(10),   1.E-14);
    Assert.assertEquals(3.597739657143682,  MathHelper.harmonisch(20),   1.E-14);
    Assert.assertEquals(4.499205338329425,  MathHelper.harmonisch(50),   1.E-14);
    Assert.assertEquals(10.480728217229327, MathHelper.harmonisch(20000),1.E-14);
  }
  @Test public void test_220_testHarmonisch() {
    Assert.assertEquals(10.480728217229327, MathHelper.harmonisch(20000),1.E-14);
  }
}
