package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe1.StringHelper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration"})
public class Test_StringHelper extends ExaminationTestDefaults {

  @Test @Marking(points = 4) public void test_050_testMindestlaengeNull() {
    try {
      Assert.assertTrue(StringHelper.hatMindestlaenge(null, 0));
      for (int i = 1; i <= 100; i++) {
        Assert.assertFalse(StringHelper.hatMindestlaenge(null, i));
      }
    } catch (final NullPointerException e) {
      Assert.fail("Ein null String darf nicht zu einer NullPointerException führen");
    }

  }

  @Test @Marking(points = 5) public void test_060_mindestLaenge() {

    final String[] tests = {"", "Eva", "Anton", "Mal sehen!", "Und noch ein wenig länger als alle Anderen!!"};

    for (final String s: tests) {
      for (int i = 0; i <= s.length(); i++) {
        Assert.assertTrue(StringHelper.hatMindestlaenge(s, i));
      }
      for (int i = 1 + s.length(); i < s.length() + 300; i++) {
        Assert.assertFalse(StringHelper.hatMindestlaenge(s, i));
      }
    }
  }

  @Test public void test_100_stundenlohn_null() {
    Assert.assertEquals(-1, StringHelper.berechneStundenlohn(null, false, false));
    Assert.assertEquals(-1, StringHelper.berechneStundenlohn(null, true, false));
    Assert.assertEquals(-1, StringHelper.berechneStundenlohn(null, false, true));
    Assert.assertEquals(-1, StringHelper.berechneStundenlohn(null, true, true));
  }

  @Test public void test_120_stundenlohn_invalid() {
    Assert.assertEquals(-1, StringHelper.berechneStundenlohn("Do.", false, false));
    Assert.assertEquals(-1, StringHelper.berechneStundenlohn("Sa", true, false));
    Assert.assertEquals(-1, StringHelper.berechneStundenlohn("Monday", false, true));
    Assert.assertEquals(-1, StringHelper.berechneStundenlohn("Phantasie", true, true));
  }

  @Test public void test_130_stundenlohn_standard() {
    Assert.assertEquals(15, StringHelper.berechneStundenlohn("Montag", false, false));
    Assert.assertEquals(15, StringHelper.berechneStundenlohn("Dienstag", false, false));
    Assert.assertEquals(15, StringHelper.berechneStundenlohn("Mittwoch", false, false));
    Assert.assertEquals(15, StringHelper.berechneStundenlohn("Donnerstag", false, false));
    Assert.assertEquals(15, StringHelper.berechneStundenlohn("Freitag", false, false));
    Assert.assertEquals(20, StringHelper.berechneStundenlohn("Samstag", false, false));
    Assert.assertEquals(20, StringHelper.berechneStundenlohn("Sonntag", false, false));
  }

  @Test public void test_140_stundenlohn_Feiertag_Tagschicht() {
    Assert.assertEquals(25, StringHelper.berechneStundenlohn("Montag", false, true));
    Assert.assertEquals(25, StringHelper.berechneStundenlohn("Sonntag", false, true));

    Assert.assertEquals(25 + 10, StringHelper.berechneStundenlohn("Montag", true, true));
    Assert.assertEquals(25 + 10, StringHelper.berechneStundenlohn("Sonntag", true, true));
  }

  @Test public void test_140_stundenlohn_normal_Nachtschicht() {
    Assert.assertEquals(2 * 15, StringHelper.berechneStundenlohn("Montag", true, false));
    Assert.assertEquals(2 * 15, StringHelper.berechneStundenlohn("Dienstag", true, false));
    Assert.assertEquals(2 * 15, StringHelper.berechneStundenlohn("Mittwoch", true, false));
    Assert.assertEquals(2 * 15, StringHelper.berechneStundenlohn("Donnerstag", true, false));
    Assert.assertEquals(2 * 15, StringHelper.berechneStundenlohn("Freitag", true, false));
    Assert.assertEquals(2 * 20, StringHelper.berechneStundenlohn("Samstag", true, false));
    Assert.assertEquals(2 * 20, StringHelper.berechneStundenlohn("Sonntag", true, false));
  }
}
