package de.hdm_stuttgart.mi.sd1.test.aufgabe2;


import de.hdm_stuttgart.mi.sd1.aufgabe2.Artikel;
import de.hdm_stuttgart.mi.sd1.test.helper.ReflectionHelper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;

import java.lang.reflect.InvocationTargetException;

/**
 * .
 *
 */

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration"})
public class Test_Artikel extends ExaminationTestDefaults {

  private final ReflectionHelper rHelper = new ReflectionHelper();

  private Artikel fussBall, ball, puzzle, flummi;

  private void init() {
    fussBall = newArtikel("Fußball", 234, 2250);
    ball = newArtikel("Ball", 234, 1030);
    puzzle = newArtikel("250 Teile Puzzle", 400, 780);
    flummi = newArtikel("Flummi", 420, 89);

  }

  private Artikel newArtikel(final String artikelBezeichnung, final int artikelNummer, final int preis) {
    try {
      final String msg = rHelper.artikel_new_Bez_id_preis.getRecursiveMsg();
      Assert.assertNull(msg, msg);

      return rHelper.artikel_new_Bez_id_preis.constructor.
          newInstance(artikelBezeichnung, artikelNummer, preis);
    } catch (InstantiationException | IllegalAccessException | IllegalArgumentException
        | InvocationTargetException e) {
      Assert.fail("Konnte »new Artikel(\"" + artikelBezeichnung + "\", " + artikelNummer + ", " +
          preis + ")« nicht aufrufen.");
    }
    return null;
  }

  @Test @Marking(points = 4) public void test_100_constructorDefined() {
    final String msg = rHelper.artikel_new_Bez_id_preis.getRecursiveMsg();
    Assert.assertNull(msg, msg);
  }

  @Test @Marking(points = 4) public void test_200_erzeugeArtikel() {
    init();
  }

  @Test @Marking(points = 2) public void test_300_equalsAlien() {
    init();
    Assert.assertNotEquals(fussBall, "Ball"); // Alien String Objekt

  }

  @Test public void test_305_equals() {
    init();

    Assert.assertFalse(fussBall.equals(null));

    Assert.assertTrue(fussBall.equals(ball));  // Gleiche Artikelnummer
    Assert.assertFalse(fussBall.equals(flummi)); // Ungleiche Artikelnummer
  }

  @Test public void test_310_hashCode() {
    init();
    Assert.assertEquals(fussBall.hashCode(), ball.hashCode());
  }

  @Test @Marking(points = 3) public void test_320_hashCodeQuality() {

    final int hashcode_1001;
    {
      final Artikel referenz = newArtikel("Dummy", 1001, 2250);
      hashcode_1001 = referenz.hashCode();
    }

    int countEqual1000 = 0;
    for (int i = 1; i <= 1000; i++) {
      final Artikel a = newArtikel("Dummy", i, 2250);
      if (hashcode_1001 == a.hashCode()) {
        countEqual1000++;
      }
    }
    Assert.assertTrue( countEqual1000 / 10. + "% identische Hash Werte: Very bad!",
        countEqual1000 < 20); // Identische Hash Werte unter 2%
  }

  @Test @Marking(points = 2) public void test_400_toString() {
    init();
    Assert.assertEquals("Fußball, Artikelnummer 234 zu 22.50€", fussBall.toString());
    Assert.assertEquals("250 Teile Puzzle, Artikelnummer 400 zu 7.80€", puzzle.toString());
  }

  @Test @Marking(points = 3) public void test_500_toString_nurCent() {
    init();
    Assert.assertEquals("Flummi, Artikelnummer 420 zu 0.89€", flummi.toString());
  }
}
