package de.hdm_stuttgart.mi.sd1.aufgabe1;

/**
 * Hilfsmethoden.
 */
public class Helper {

  /**
   * Sind alle drei Strings von <code>null</code> verschieden?
   *
   * @param s1 Erster String oder <code>null</code>
   * @param s2 Zweiter String oder <code>null</code>
   * @param s3 Dritter String oder <code>null</code>
   * @return <code>true</code>, falls alle drei Strings von <code>null</code> verschieden sind, sonst <code>false</code>.
   */
  public static boolean keinStringIstNull(final String s1, final String s2, final String s3) {
    return null != s1 && null != s2 && null != s3;
  }
  /**
   * <p>Sind alle drei Strings von <code>null</code> verschieden und haben alle drei Strings die Mindestlänge 1?
   * Beispiele:</p>
   *
   * <ul>
   *   <li><code>alleMindestlaengeEins("A", "Maus", "Tip")</code>: <code>true</code>, da Längen 1, 4 und 3 alle
   *   größer/gleich 1</li>
   *   <li><code>alleMindestlaengeEins(null, "Test", "Pech")</code>: <code>false</code>, da erstes Argument
   *   <code>null</code>.</li>
   *   <li><code>alleMindestlaengeEins("Boden", "B", "")</code>: <code>false</code>, da drittes Argument die
   *   Länge 0 hat</li>
   * </ul>
   *
   * @param s1 Erster String oder <code>null</code>
   * @param s2 Zweiter String oder <code>null</code>
   * @param s3 Dritter String oder <code>null</code>
   * @return <code>true</code>, falls alle drei Strings nicht <code>null</code> sind und eine Mindestlänge 1 haben,
   * sonst <code>false</code>.
   */
  public static boolean alleMindestlaengeEins(final String s1, final String s2, final String s3) {
    return mindestlaengeEins(s1) && mindestlaengeEins(s2) && mindestlaengeEins(s3);
  }

  private static boolean mindestlaengeEins(final String s) {
    return null != s && 0 < s.length();
  }


  /**
   * <p>Ist a durch b oder b durch a ohne Rest teilbar? Beispiele:</p>
   *
   * <ul>
   *   <li><code>istIrgendwieTeilbar(5, 20)</code>: <code>true</code>, da 20 durch 5 teilbar</li>
   *   <li><code>istIrgendwieTeilbar(20, 5)</code>: <code>true</code>, da 20 durch 5 teilbar</li>
   *   <li><code>istIrgendwieTeilbar(1, 8)</code>: <code>true</code>, da 8 durch 1 teilbar</li>
   *   <li><code>istIrgendwieTeilbar(3, 0)</code>: <code>true</code>, da 0 durch 3 teilbar</li>
   *   <li><code>istIrgendwieTeilbar(20, 3)</code>: <code>false</code>, da weder 20 durch 3 noch 3 durch 20 teilbar</li>
   *   <li><code>istIrgendwieTeilbar(0, 0)</code>: <code>false</code>, da 0 nicht teilbar durch 0</li>
   * </ul>
   *
   * @param a Erster Wert.
   * @param b Zweiter Wert.
   * @return <code>true</code>, falls entweder b durch a oder a durch b teilbar ist, sonst <code>false</code>.
   *  Achtung: Es gibt keine Division durch den Wert 0.
   *
   */
  public static boolean istIrgendwieTeilbar(final int a, final int b) {
    return (0 != b && 0 == a % b) || (0 != a && 0 == b % a);
  }

  /**
   * <p>Ersetze jedes Leerzeichen <code>' '</code> zur besseren Erkennung durch ein '_'. Beispiel:</p>
   *
   *<table>
   *  <tr>
   *    <th>Code</th>
   *    <th>Ergebnis</th>
   *  </tr>
   *  <tr>
   *    <td style="vertical-align:top">
   *      <pre> System.out.println(
   *         Helper.markiereLeerzeichen(
   *             "This is  important! "));</pre>
   *     </td>
   *     <td style="vertical-align:top">
   *       <pre>This<span style="color:red;">_</span>is<span
   *          style="color:red;">__</span>important!<span style="color:red;">_</span></pre>
   *     </td>
   *   </tr>
   * </table>
   *
   * <section class="implementationHints">
   *   <h3>Hinweis:</h3>
   *   <p>{@link String#replace(char, char)}.</p>
   * </section>
   *
   * @param s Eingabestring
   * @return Eingabestring mit <code>'_'</code> statt Leerzeichen <code>' '</code>.
   */
  public static String markiereLeerzeichen(final String s) {
    return s.replace(' ', '_');
  }
}