package de.hdm_stuttgart.mi.sd1.aufgabe1;


/**
 * <p>Darstellung von Personen unter Angabe von Vorname, Name und Geschlecht. Typische Verwendung:</p>
 *
 * <pre style="background:LightCyan;width: 95ex; "
 * > final Person ute = new Person("Ute", "Kurz", Person.WEIBLICH);
 *
 * System.out.println(ute.getAnrede()); <b style="color:red;">// Ausgabe: "Sehr geehrte Frau Kurz"</b>
 *
 * System.out.println(ute); <b style="color:red;">// Ausgabe: "Ute Kurz (w)"</b></pre>
 */
public class Person {

  /**
   * Geschlechtsangabe »weiblich«
   *
   */
  static public final char WEIBLICH = 'w';

  /**
   * Geschlechtsangabe »männlich«
   */
  static public final char MAENNLICH = 'm';


  private final String vorname, nachname;
  private  char geschlecht;

  /**
   * <p>Anlegen einer neuen Person. Zur Vermeidung von Programmierfehlern sollten die beiden Fixwerte
   *    * {@link #WEIBLICH} bzw. {@link #MAENNLICH} zur Geschlechtsangabe verwendet werden, also z.B.:</p>
   *
   * <pre style="background:LightCyan;width: 80ex; "
   * >{@code Person m = new Person("Renate", "Musterfrau", Person.WEIBLICH);}</pre>
   *
   * @param vorname Vorname der Person
   * @param nachname Nachname der Person
   * @param geschlecht Geschlechtsangabe der Person.
   */
  public Person(final String vorname, final String nachname, final char geschlecht) {
    this.vorname = vorname;
    this.nachname = nachname;
    this.geschlecht = geschlecht;
  }

  /**
   * <p>Erzeugung einer geschlechtsspezifischen Anrede unter Verwendung des Nachnamens, also z.B.:</p>
   *
   * <ul>
   *   <li><pre>Sehr geehrte Frau Musterfrau</pre></li>
   *   <li><pre>Sehr geehrter Herr Schulz</pre></li>
   * </ul>
   *
   * @return Die Angrede basierend auf Nachname und Geschlecht.
   */
  public String getAnrede() {
    return "Sehr geehrte" + (geschlecht == MAENNLICH ? "r Herr " : " Frau ")  + nachname;
  }

  @Override
  public String toString() {
    return vorname + " " + nachname + " (" + geschlecht + ")";
  }
}