package de.hdm_stuttgart.mi.sd1.task1;

/**
 * Helper methods.
 */
public class Helper {

    /**
     * <p>Check whether three integer values are being provided in a strictly ascending order. Examples:</p>
     *
     * <table class="goikTableDefaults">
     *
     *     <tr>
     *         <th>Values</th>
     *         <th>Result</th>
     *     </tr>
     *
     *     <tr>
     *         <td>{-1, 3, 7}</td>
     *         <td>Strictly ascending</td>
     *     </tr>
     *
     *     <tr>
     *         <td>{1, 5, 4}</td>
     *         <td>Not strictly ascending since <code>5 &lt; 4</code> is false.</td>
     *     </tr>
     *
     *     <tr>
     *         <td>{1, 2, 2}</td>
     *         <td>Not strictly ascending since <code>2 &lt; 2</code> is false.</td>
     *     </tr>
     *
     * </table>
     *
     * @param a The first integer value.
     * @param b The second integer value.
     * @param c The third integer value.
     * @return <code>true</code> if all three values are in strictly ascending order, <code>false</code> otherwise.
     */
    static public boolean isAscending(final int a, final int b, final int c) {
        return true; // TODO:Implement me correctly
    }

    /**
     * <p>A valid title text shall obey the following conditions:</p>
     * <ul>
     *     <li>It must begin with a capital letter.</li>
     *     <li>It must have a length of at least 20 characters.</li>
     * </ul>
     *
     * <p>Examples:</p>
     *
     * <table class="goikTableDefaults">
     *
     *     <tr>
     *         <th>Title</th>
     *         <th colspan="2">Result</th>
     *     </tr>
     *
     *     <tr>
     *         <td><span style="color:red">T</span>his is all quite correct</td>
     *         <td>Valid</td>
     *         <td>Length of 25 character and <span style="color:red">'T'</span> being a capital letter</td>
     *     </tr>
     *
     *     <tr>
     *         <td><span style="color:red">4</span>all of you: This is bullshit!</td>
     *         <td>Invalid</td>
     *         <td><span style="color:red">'4'</span> is not a letter but a digit</td>
     *     </tr>
     *
     *     <tr>
     *         <td>Too short!</td>
     *         <td>Invalid</td>
     *         <td>20 characters are being required</td>
     *     </tr>
     *
     *     <tr>
     *         <td><span style="color:red">l</span>ooks promising but flawed anyway</td>
     *         <td>Invalid</td>
     *         <td><span style="color:red">l</span> is small caps rather than a capital letter</td>
     *     </tr>
     *
     * </table>
     *
     * <section class="implementationHints">
     *
     *     <h3>Implementation hints:</h3>
     *
     *     <ul>
     *         <li>See {@link Character#isUpperCase(char)}.</li>
     *         <li>See {@link Character#isLetter(char)}.</li>
     *     </ul>
     *
     * </section>
     *
     * @param title The title text to be examined
     * @return <code>true</code> if title is non-null and its text meets both conditions,
     *          <code>false</code> otherwise.
     */
    public static boolean checkTitle(final String title) {
        return true; // TODO:Implement me correctly
    }

    /** <p>Tell whether a given character is a vowel or not. The set of vowels is:</p>
     *
     * <p><code>{a, e, i, o, u}</code> plus the five corresponding uppercase counterparts.</p>
     *
     * @param candidate The character to be examined.
     * @return <code>true</code> if the given character is a vowel, <code>false</code> otherwise.
     */

    static public boolean isVowel(final char candidate) {
        return true; // TODO:Implement me correctly
    }

    /**
     * <p>Count a string's number of vowels according to {@link #isVowel(char)}. Examples:</p>
     *
     * <table class="goikTableDefaults">
     *   <tr>
     *     <th>String</th>
     *     <th>Vowel count</th>
     *   </tr>
     *
     *   <tr>
     *     <td><code>null</code></td>
     *     <td>0</td>
     *   </tr>
     *
     *   <tr>
     *     <td>Thx</td>
     *     <td>0</td>
     *   </tr>
     *
     *   <tr>
     *     <td><span style="color:red">A</span> T<span style="color:red">e</span>st.</td>
     *     <td>2</td>
     *   </tr>
     *
     *   <tr>
     *     <td>Th<span style="color:red">i</span>s <span style="color:red">i</span>s q<span
     *       style="color:red">ui</span>t<span style="color:red">e</span> s<span style="color:red">i</span>mpl<span
     *       style="color:red">e</span>.</td>
     *     <td>7</td>
     *   </tr>
     * </table>
     *
     * <section class="implementationHints">
     *
     *     <h3>Implementation hint:</h3>
     *
     *     <p>Use your own {@link #isVowel(char)}} implementation.</p>
     *
     * </section>
     *
     * @param s A string possibly containing vowels
     * @return The number of vowels being contained within the string in question. Zero in case of a <code>null</code>
     * input value.
     */
    static public int getNumberOfVowels(final String s) {
        return -12345; // TODO:Implement me correctly
    }

    /**
     * <p>Renaming file base names.</p>
     *
     * <p>File names typically consist of a <span style="color:red">base name</span> separated from an
     * <span style="color:green">extension</span> by the first dot <code>'.'</code>
     * character i.e. «<code style="color:red">pre70</code><code>.</code><code style="color:green">pdf</code>».</p>
     *
     * <p>In presence of an extension renaming a file typically refers to
     * changing just a file's basename rather than its extension as well:</p>
     *
     * <table class="goikTableDefaults">
     *     <tr>
     *         <th>Renaming <code style="color:red">pre70</code><code>.</code><code style="color:green">pdf</code> to
     *         <code style="color:red">post70</code><code>.</code><code style="color:green">pdf</code>.</th>
     *
     *         <th>Renaming <code style="color:red">xmlmind</code><code>.</code><code style="color:green">tar.bz2</code> to
     *         <code style="color:red">other</code><code>.</code><code style="color:green">tar.bz2</code></th>
     *     </tr>
     *
     *     <tr>
     *         <td><object data="doc-files/renamePdf.png" type="image/png"></object></td>
     *
     *         <td><object data="doc-files/renameArchive.png" type="image/png"></object></td>
     *     </tr>
     * </table>
     *
     *
     * <section class="implementationHints">
     *  <p><b>Implementation hints:</b></p>
     *  <ul>
     *      <li>See {@link String#indexOf(int)}</li>
     *      <li>See {@link String#substring(int)}</li>
     *  </ul>
     *
     * </section>
     *
     * @param filename The complete file name possibly including an extension.
     * @param newBasename The intended new base name excluding a possible extension.
     * @return Replacing the filename up to the <strong>first</strong> occurrence of an extension separation
     *      <code>'.'</code> character. If no separation character is present, the entire name will be replaced.
     */
    public static String renameFileBasename(final String filename, final String newBasename) {
        return "Too sad!"; // TODO:Implement me correctly
    }
}