package de.hdm_stuttgart.mi.sd1.test.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import java.util.Arrays;

import static de.hdm_stuttgart.mi.sd1.task1.HelperArray.getAlphabeticalFollowers;
import static de.hdm_stuttgart.mi.sd1.task1.HelperArray.getLeaders;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_120_HelperArray_getLeaders extends ExaminationTestDefaults {

  @Test public void test_600_singleLeader() {
    Assert.assertArrayEquals(new int[]{-3}, getLeaders(new int[]{-3}));
    Assert.assertArrayEquals(new int[]{1, 0}, getLeaders(new int[]{1, 0}));
    Assert.assertArrayEquals(new int[]{1}, getLeaders(new int[]{0, 1}));
  }

  @Test public void test_620_edgeDuplicate() {
    Assert.assertArrayEquals(new int[]{3, 3}, getLeaders(new int[]{1, 3, -2, 0, 3}));
    Assert.assertArrayEquals(new int[]{4, 3}, getLeaders(new int[]{1, 4, -2, 0, 3}));
    Assert.assertArrayEquals(new int[]{3}, getLeaders(new int[]{1, 2, -2, 0, 3}));
    Assert.assertArrayEquals(new int[]{3, 3}, getLeaders(new int[]{3, 2, -2, 0, 3}));
    Assert.assertArrayEquals(new int[]{6, 3}, getLeaders(new int[]{6, 2, -2, 0, 3}));
    Assert.assertArrayEquals(new int[]{17, 5, 2}, getLeaders(new int[]{16, 17, 4, 3, 5, 2}));
  }

  @Test public void test_640_all() {
    Assert.assertArrayEquals(new int[]{5,4,3,2,1,0}, getLeaders(new int[]{5,4,3,2,1,0}));
    Assert.assertArrayEquals(new int[]{4,4,4,4,4,4,4}, getLeaders(new int[]{4,4,4,4,4,4,4}));
  }
}