package de.hdm_stuttgart.mi.sd1.test.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.task1.Helper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_20_Helper_checkTitle extends ExaminationTestDefaults {

  /* Section: checkTitle */

  @Test @Marking(points = 2) public void test_210_checkTitle_null() {
    Assert.assertFalse("a null title is invalid", Helper.checkTitle(null));
    Assert.assertTrue(Helper.checkTitle("This is definitely fine"));
  }
  @Test @Marking(points = 2) public void test_checkTitle_010_tooShort() {
    Assert.assertFalse("title too short", Helper.checkTitle("A"));
    Assert.assertFalse("title too short", Helper.checkTitle("Abcde"));
    Assert.assertFalse("title too short", Helper.checkTitle("A123456789012345678"));
    Assert.assertTrue( Helper.checkTitle("A1234567890123456789"));
    Assert.assertTrue( Helper.checkTitle("A12345678901234567890"));
  }

  @Test @Marking(points = 1) public void test_220_checkTitle_smallCaps() {
    Assert.assertFalse("title too short and first char small caps", Helper.checkTitle("a"));
    Assert.assertFalse("title too short and first char small caps", Helper.checkTitle("abcde"));
    Assert.assertFalse("title too short and first char small caps", Helper.checkTitle("a123456789012345678"));
    Assert.assertFalse("first char small caps", Helper.checkTitle("a1234567890123456789"));
    Assert.assertFalse("first char small caps", Helper.checkTitle("a12345678901234567890"));
    Assert.assertTrue( Helper.checkTitle("A12345678901234567890"));
  }

  @Test @Marking(points = 1) public void test_225_checkTitle_letter() {

      Assert.assertFalse("Invalid: Non-letter (digit) at beginning",
              Helper.checkTitle("4all of you: This is bullshit!"));
      Assert.assertFalse("Invalid: Non-letter(underscore) at beginning",
              Helper.checkTitle("_all of you: This is bullshit!"));
    Assert.assertTrue(Helper.checkTitle("For all of you: This is valid!"));
    Assert.assertTrue(Helper.checkTitle("A12345678901234567890"));
  }

  @Test @Marking(points = 2) public void test_230_checkTitle_Small() {
    Assert.assertFalse("title too short and first char small caps", Helper.checkTitle("too short"));
    Assert.assertFalse("title too short", Helper.checkTitle("Too short"));
    Assert.assertTrue( Helper.checkTitle("A12345678901234567890"));
  }

  @Test @Marking(points = 2) public void test_240_checkTitle_Long() {
    Assert.assertFalse("first char small caps", Helper.checkTitle("you should not start with small caps"));
    Assert.assertTrue(Helper.checkTitle("You should not start with small caps"));
  }

}