package de.hdm_stuttgart.mi.sd1.test.task2;

import de.hdm_stuttgart.mi.sd1.task2.ChangeAmount;
import de.hdm_stuttgart.mi.sd1.task2.money.Coin;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;

/**
 * .
 *
 */

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_ChangeAmount extends ExaminationTestDefaults {
  
  private final ChangeAmount c = new ChangeAmount();

  /**
   * Helper method for testing: Setting new cent value
   * and returning array of coin counts to be examined.
   *
   * @param value The desired amount of cents
   * @return An array containing all eight (see @link #Coin) coin counts
   */
  private int[] set(final int value) {
    c.setAmount(value);
    return c.getCoins(Coin.values());
  }

  @Test @Marking(points = 8) public void test_0020_setCoin() {

    final ChangeAmount c = new ChangeAmount();
    c.setAmount(0);

    c.setCoin(Coin.CENT_50, 3); Assert.assertEquals(150, c.getAmount());
    c.setCoin(Coin.CENT_50, 1); Assert.assertEquals(50, c.getAmount());
    c.setCoin(Coin.EURO_2, 3); Assert.assertEquals(650, c.getAmount());
    c.setCoin(Coin.EURO_1, 1); Assert.assertEquals(750, c.getAmount());
    c.setCoin(Coin.CENT_02, 2); Assert.assertEquals(754, c.getAmount());

    c.setAmount(0); Assert.assertEquals(0, c.getAmount());
  }

  @Test @Marking(points = 2) public void test_0100_5Cent() {
    Assert.assertArrayEquals(new int[]{0,0,0,0,0,0,0,0}, set(0));
    Assert.assertArrayEquals(new int[]{1,0,0,0,0,0,0,0}, set(1));
    Assert.assertArrayEquals(new int[]{0,1,0,0,0,0,0,0}, set(2));
    Assert.assertArrayEquals(new int[]{1,1,0,0,0,0,0,0}, set(3));
    Assert.assertArrayEquals(new int[]{0,2,0,0,0,0,0,0}, set(4));
    Assert.assertArrayEquals(new int[]{0,0,1,0,0,0,0,0}, set(5));
  }
  @Test @Marking(points = 2) public void test_0120_10Cent() {
    Assert.assertArrayEquals(new int[]{1,0,1,0,0,0,0,0}, set(6));
    Assert.assertArrayEquals(new int[]{0,1,1,0,0,0,0,0}, set(7));
    Assert.assertArrayEquals(new int[]{1,1,1,0,0,0,0,0}, set(8));
    Assert.assertArrayEquals(new int[]{0,2,1,0,0,0,0,0}, set(9));
    Assert.assertArrayEquals(new int[]{0,0,0,1,0,0,0,0}, set(10));
  }
  @Test @Marking(points = 2) public void test_0140_20Cent() {
    Assert.assertArrayEquals(new int[]{1,0,0,1,0,0,0,0}, set(11));
    Assert.assertArrayEquals(new int[]{0,1,0,1,0,0,0,0}, set(12));
    Assert.assertArrayEquals(new int[]{1,1,0,1,0,0,0,0}, set(13));
    Assert.assertArrayEquals(new int[]{0,2,0,1,0,0,0,0}, set(14));
    Assert.assertArrayEquals(new int[]{0,0,1,1,0,0,0,0}, set(15));
    Assert.assertArrayEquals(new int[]{1,0,1,1,0,0,0,0}, set(16));
    Assert.assertArrayEquals(new int[]{0,1,1,1,0,0,0,0}, set(17));
    Assert.assertArrayEquals(new int[]{1,1,1,1,0,0,0,0}, set(18));
    Assert.assertArrayEquals(new int[]{0,2,1,1,0,0,0,0}, set(19));
    Assert.assertArrayEquals(new int[]{0,0,0,0,1,0,0,0}, set(20));
  }
  @Test @Marking(points = 2) public void test_0160_50Cent() {
    Assert.assertArrayEquals(new int[]{0,0,0,0,2,0,0,0}, set(40));
    Assert.assertArrayEquals(new int[]{1,0,0,0,2,0,0,0}, set(41));
    Assert.assertArrayEquals(new int[]{0,1,0,0,2,0,0,0}, set(42));
    Assert.assertArrayEquals(new int[]{1,1,0,0,2,0,0,0}, set(43));
    Assert.assertArrayEquals(new int[]{0,2,0,0,2,0,0,0}, set(44));
    Assert.assertArrayEquals(new int[]{0,0,1,0,2,0,0,0}, set(45));
    Assert.assertArrayEquals(new int[]{1,0,1,0,2,0,0,0}, set(46));
    Assert.assertArrayEquals(new int[]{0,1,1,0,2,0,0,0}, set(47));
    Assert.assertArrayEquals(new int[]{1,1,1,0,2,0,0,0}, set(48));
    Assert.assertArrayEquals(new int[]{0,2,1,0,2,0,0,0}, set(49));
    Assert.assertArrayEquals(new int[]{0,0,0,0,0,1,0,0}, set(50));
  }
  @Test @Marking(points = 2) public void test_0180_75Cent() {
    Assert.assertArrayEquals(new int[]{1,0,0,0,0,1,0,0}, set(51));
    Assert.assertArrayEquals(new int[]{0,1,0,0,0,1,0,0}, set(52));
    Assert.assertArrayEquals(new int[]{1,1,0,0,0,1,0,0}, set(53));
    Assert.assertArrayEquals(new int[]{0,2,0,0,0,1,0,0}, set(54));

    Assert.assertArrayEquals(new int[]{0,0,1,0,0,1,0,0}, set(55));
    Assert.assertArrayEquals(new int[]{1,0,1,0,0,1,0,0}, set(56));
    Assert.assertArrayEquals(new int[]{0,1,1,0,0,1,0,0}, set(57));
    Assert.assertArrayEquals(new int[]{1,1,1,0,0,1,0,0}, set(58));
    Assert.assertArrayEquals(new int[]{0,2,1,0,0,1,0,0}, set(59));

    Assert.assertArrayEquals(new int[]{0,0,0,1,0,1,0,0}, set(60));
    Assert.assertArrayEquals(new int[]{1,0,0,1,0,1,0,0}, set(61));
    Assert.assertArrayEquals(new int[]{0,1,0,1,0,1,0,0}, set(62));
    Assert.assertArrayEquals(new int[]{1,1,0,1,0,1,0,0}, set(63));
    Assert.assertArrayEquals(new int[]{0,2,0,1,0,1,0,0}, set(64));
    Assert.assertArrayEquals(new int[]{0,0,1,1,0,1,0,0}, set(65));
    Assert.assertArrayEquals(new int[]{1,0,1,1,0,1,0,0}, set(66));
    Assert.assertArrayEquals(new int[]{0,1,1,1,0,1,0,0}, set(67));
    Assert.assertArrayEquals(new int[]{1,1,1,1,0,1,0,0}, set(68));
    Assert.assertArrayEquals(new int[]{0,2,1,1,0,1,0,0}, set(69));

    Assert.assertArrayEquals(new int[]{0,0,0,0,1,1,0,0}, set(70));
    Assert.assertArrayEquals(new int[]{1,0,0,0,1,1,0,0}, set(71));
    Assert.assertArrayEquals(new int[]{0,1,0,0,1,1,0,0}, set(72));
    Assert.assertArrayEquals(new int[]{1,1,0,0,1,1,0,0}, set(73));
    Assert.assertArrayEquals(new int[]{0,2,0,0,1,1,0,0}, set(74));

    Assert.assertArrayEquals(new int[]{0,0,1,0,1,1,0,0}, set(75));
  }
  @Test @Marking(points = 2) public void test_0200_1000Cent() {
    Assert.assertArrayEquals(new int[]{0,2,1,0,2,1,1,0}, set(199));
    Assert.assertArrayEquals(new int[]{0,2,1,0,2,1,0,1}, set(299));
    Assert.assertArrayEquals(new int[]{0,2,1,0,2,1,1,1}, set(399));
    Assert.assertArrayEquals(new int[]{0,2,1,0,2,1,0,2}, set(499));
    Assert.assertArrayEquals(new int[]{0,2,1,0,2,1,1,2}, set(599));
    Assert.assertArrayEquals(new int[]{0,2,1,0,2,1,0,3}, set(699));
    Assert.assertArrayEquals(new int[]{0,2,1,0,2,1,1,3}, set(799));
    Assert.assertArrayEquals(new int[]{0,1,1,1,1,1,0,4}, set(887));
    Assert.assertArrayEquals(new int[]{1,1,1,1,1,1,1,4}, set(988));
  }
}