package de.hdm_stuttgart.sw1.klausur.test;

import static org.junit.Assert.assertEquals;

import org.junit.FixMethodOrder;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.DisableOnDebug;
import org.junit.rules.TestRule;
import org.junit.rules.Timeout;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.sd1.diff.Diff;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration", "javadoc"})
public class Test_MaxDiff {

	// Kill test if tests last longer than 1000 milliseconds unless in debugging mode
	@Rule
	public final TestRule timeout = new DisableOnDebug(Timeout.millis(1000));
	
	   @Test
	   public void test01Zero() {
		    assertEquals(0, Diff.maxDiff(0, 0, 0));
	   }
	   @Test
	   public void test02Equal() {
		    assertEquals(0, Diff.maxDiff(1, 1, 1));
	   }
	   @Test
	   public void test03AscendingValues() {
		    assertEquals(2, Diff.maxDiff(1, 2, 3));
	   }
	   @Test
	   public void test04DescendingValues() {
		    assertEquals(7, Diff.maxDiff(7, 5, 0));
	   }
	   @Test
	   public void test05Middle() {
		    assertEquals(3, Diff.maxDiff(4, 1, 4));
	   }
	   @Test
	   public void test06Negative() {
		    assertEquals(3, Diff.maxDiff(-1, -2, -4));
	   }
	   @Test
	   public void test07Mixed() {
		    assertEquals(15, Diff.maxDiff(-5, 10, 0));
		    assertEquals(37, Diff.maxDiff(-5, 30, -7));
	   }
}
