#!/usr/bin/perl

my $xsdFile = $ARGV[0];
my $reportFile = $xsdFile . ".log";

system("ln -sf $xsdFile letter.xsd");



my %negatives = (
"displayNoBoolean", "'no' is not a valid value for 'boolean'.",
"missingSignature", "Invalid content was found starting with element 'address'. One of '{signature}' is expected.",
"noParagraph",  "Invalid content was found starting with element 'complimentaryClose'. One of '{paragraph}' is expected.",
"wrongDate",  "'20.04.2015' is not a valid value for 'date'.",
"missingAbout", "Invalid content was found starting with element 'date'. One of '{about}' is expected.",
"missingZip", "Invalid content was found starting with element 'town'. One of '{zip}' is expected.",
"salutation31", "Value '012345678901234567890123456789X' with length = '31' is not facet-valid with respect to maxLength '30' "
);

my @positive = ("missingCompany", "displayTrue", "lettersample");

system("rm -f  $reportFile");

my $points = 0;

foreach my $negTest (keys(%negatives)) {
    my $xmlInputFile = "Negative/" . $negTest . ".xml";
    my $xmlInputLogFile =  $xmlInputFile . ".log";
    
    system ("echo Testing invalid file $xmlInputFile >> $reportFile");
    system("xmlparse  -V -s $xmlInputFile > $xmlInputLogFile 2>&1");
    my $exitValue  = $? >> 8;
    if (0 !=  $exitValue) {
	my $errOutput = `cat $xmlInputLogFile|head -1`;
	chop($errOutput);
	my @errMsgComponents = split("[ \t]*:[ \t]*", $errOutput);
	my $errMsg =  @errMsgComponents[$#errMsgComponents];
	my $expectedErrorMessage = $negatives{$negTest};
	if (index($errMsg, $expectedErrorMessage) != -1) {
	    system ("echo Expected error message: $errMsg, adding 1 point >> $reportFile");
	    $points++
	} else {
	     system ("echo expected $expectedErrorMessage not found in $errMsg >> $reportFile");
	}

    } else {
	system ("echo Invalid file not being flagged as invalid, schema error >> $reportFile");
    }

#    system("cat $xmlInputLogFile  >> $reportFile");

    system ("echo ____________________________________________________ >> $reportFile");
} 

foreach my $posTest (@positive) {
    my $xmlInputFile = "Positive/" . $posTest . ".xml";
    
    system ("echo Testing valid file $xmlInputFile >> $reportFile");
    system("xmlparse  -V -s $xmlInputFile >> $reportFile 2>> $reportFile");
    my $exitValue  = $? >> 8;
    if (0 ==  $exitValue) {
	system ("echo Validity confirmed expectedly, adding 1 point >> $reportFile");
	$points++
    } else {
	system ("echo Valid File flagged as invalid, schema error >> $reportFile");
    }
    system ("echo ____________________________________________________ >> $reportFile");
} 

system ("echo Summary: $points out of 10 points have been reached >> $reportFile");


#end
