DROP TABLE IF EXISTS LanguageScript, Script, Language;

CREATE TABLE Language (
  id BIGINT NOT NULL PRIMARY KEY AUTO_INCREMENT,
  language CHAR(255) NOT NULL UNIQUE
);

CREATE TABLE Script (
   id BIGINT NOT NULL PRIMARY KEY AUTO_INCREMENT
  ,xmlId CHAR(255) NOT NULL UNIQUE
  ,description CHAR(255) NOT NULL
  ,sourcecode TEXT
);

CREATE TABLE LanguageScript (
	language BIGINT NOT NULL
   ,script BIGINT NOT NULL
   ,PRIMARY KEY(language, script)
   ,FOREIGN KEY (language) REFERENCES Language(id)
   ,FOREIGN KEY (script) REFERENCES Script(id)
);

INSERT INTO Language (language)
VALUES 
  ('bourneshell')
 ,('python')
 ,('ruby')
 ,('php')
 ,('html');
 
INSERT INTO Script (xmlId, description, sourcecode)
VALUES 
   ('recursiveTextFileSearch', 'Recursively search for files having a .txt extension', 'find . -type f -and -name \*.txt')  
  ,('phpBasicHelloWorld', 'Basic "hello, world..." snippet.', '<html>...</html>');

SELECT * FROM Language;
SELECT * FROM Script;

SELECT * FROM LanguageScript;

