<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns="http://www.w3.org/1999/xhtml"
    exclude-result-prefixes="xs"
    version="2.0">
    
    <xsl:output method="xhtml" indent="yes"/>
    
    <xsl:template match="/dictionary">
        <html>
            <head>
                <title>
                    <xsl:apply-templates select="." mode="translateDirection"/>
                </title>
            </head>
            <body>
                <h1>
                    <xsl:apply-templates select="." mode="translateDirection"/>
                </h1>  
                <xsl:choose>
                    <xsl:when test="entry">
                        <dl>
                            <xsl:apply-templates select="entry"/>
                        </dl>
                    </xsl:when>
                    <xsl:otherwise><p>No entries in dictionary</p></xsl:otherwise>
                </xsl:choose>
            </body>
        </html>        
    </xsl:template>
    
    <xsl:template match="entry">
        <dt id="{from}" style="font-weight: bold;">
            <xsl:value-of select="from"/>
        </dt>
        <dd>
            <ul>
                <xsl:for-each select="translations/to">
                    <li>
                        <xsl:value-of select="."/>
                    </li>
                </xsl:for-each>
            </ul>
            <xsl:apply-templates select="synonyms"/>
            
        </dd>
        
    </xsl:template>
    
    <xsl:template match="synonyms">
        <p>
            <xsl:choose>
                <xsl:when test="1=count(from)">Synonym: </xsl:when>
                <xsl:otherwise>Synonyms: </xsl:otherwise>
            </xsl:choose>
            <xsl:for-each select="from">
                <a href="#{.}">
                    <xsl:value-of select="."/>
                </a>
                <xsl:if test="position() &lt; last()">
                    <xsl:text>, </xsl:text>
                </xsl:if>
            </xsl:for-each>
        </p>
    </xsl:template>
    
    <xsl:template match="dictionary" mode="translateDirection">
        <xsl:text>'</xsl:text>
        <xsl:value-of select="@fromLanguage"/>
        <xsl:text>' to '</xsl:text>
        <xsl:value-of select="@toLanguage"/>
        <xsl:text>' translation.</xsl:text>
    </xsl:template>
    
    
</xsl:stylesheet>