package de.hdm_stuttgart.mi.sda1.exam.rdbms;

import java.sql.SQLException;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;


/**
 * Providing some basic DB handling tests.
 *
 */
@SuppressWarnings({"UnusedDeclaration"})
public class DbhandlerManualTest {
   
   private static Logger log = LogManager.getLogger(DbhandlerManualTest.class);

   /**
    * 
    * @param args Unused
    */
   public static void main(String[] args) {
      final DbHandler dbh = new DbHandler();
      
      try {
         dbh.connect();

         final int enLangId = dbh.addLanguageIfMissing("en"),
                   deLangId = dbh.addLanguageIfMissing("de");
         
         final int nounSummerEnId = dbh.addNounIfMissing("Summer", enLangId);
         final int nounSommerDeId = dbh.addNounIfMissing("Sommer", deLangId);
         
         System.out.println(nounSummerEnId);
         System.out.println(nounSommerDeId);
         
         dbh.addTranslation(4, 5);

      } catch (SQLException e) {
         log.error("Unable to open connection", e);
      }
      
      
   }

}
