package de.hdm_stuttgart.mi.sda1.exam.xsd;

import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.exam.unitmarking.xml.XmlTestSupport;
import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.unitmarking.xsd.InstanceSetEvaluation;

/**
 * Unit test for an XML instance set.
 */
@SuppressWarnings({"UnusedDeclaration"})
public class SchemaTest {

  private final XmlTestSupport xmlTestSupport = new XmlTestSupport("SchemaTest");

  @Test @Marking(points = 1)
  public void test_doubleSynonymSection_err() {
    xmlTestSupport.assertInvalid("doubleSynonymSection_err.xml");
    xmlTestSupport.assertValid("synonym.xml");
  }

  @Test @Marking(points = 1)
  public void test_duplicateTranslationSection_err() {
    xmlTestSupport.assertInvalid("duplicateTranslationSection_err.xml");
    xmlTestSupport.assertValid("noTranslationDuplicate.xml");
  }

  @Test @Marking(points = 1)
  public void test_empty() {
    xmlTestSupport.assertValid("empty.xml");
  }

  @Test @Marking(points = 1)
  public void test_fromType_err() {
    xmlTestSupport.assertInvalid("fromType_err.xml");
    xmlTestSupport.assertValid("type.xml");
  }

  @Test @Marking(points = 1)
  public void test_language_err() {
    xmlTestSupport.assertInvalid("language_err.xml");
    xmlTestSupport.assertValid("empty.xml");
  }

  @Test @Marking(points = 1)
  public void test_missingTranslation_err() {
    xmlTestSupport.assertInvalid("missingTranslation_err.xml");
    xmlTestSupport.assertValid("translation.xml");
  }

  @Test @Marking(points = 1)
  public void test_noTranslationDuplicate_err() {
    xmlTestSupport.assertInvalid("noTranslationDuplicate_err.xml");
    xmlTestSupport.assertValid("noTranslationDuplicate.xml");
  }

  @Test @Marking(points = 1)
  public void test_synonymDuplicate_err() {
    xmlTestSupport.assertInvalid("synonymDuplicate_err.xml");
    xmlTestSupport.assertValid("synonym.xml");
  }

  @Test @Marking(points = 2)
  public void test_synonymRef_err() {
    xmlTestSupport.assertInvalid("synonymRef_err.xml");
    xmlTestSupport.assertValid("synonym.xml");
  }

  @Test @Marking(points = 1)
  public void test_toType_err() {
    xmlTestSupport.assertInvalid("toType_err.xml");
    xmlTestSupport.assertValid("type.xml");
  }
  @Test @Marking(points = 1)
  public void test_translationMinimal_err() {
    xmlTestSupport.assertInvalid("translationMinimal_err.xml");
    xmlTestSupport.assertValid("translationMinimal.xml");
  }
  @Test @Marking(points = 1)
  public void test_twoEntriesDuplicate_err() {
    xmlTestSupport.assertInvalid("twoEntriesDuplicate_err.xml");
    xmlTestSupport.assertValid("twoEntries.xml");
  }
}
