package de.hdm_stuttgart.mi.sda1.exam.xsd;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.exam.unitmarking.xml.XmlTestSupport;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;

import de.hdm_stuttgart.mi.unitmarking.xsd.InstanceSetEvaluation;
import org.junit.runners.MethodSorters;

/**
 * Unit test for an XML instance set.
 */
@SuppressWarnings({"UnusedDeclaration"})
@FixMethodOrder(value = MethodSorters.NAME_ASCENDING)
public class SchemaTest extends ExaminationTestDefaults {

  private final XmlTestSupport xmlTestSupport = new XmlTestSupport("SchemaTest");

  @Test @Marking(points = 1)
  public void test_110invalid_duplicates() {
    xmlTestSupport.assertInvalid("110invalid_duplicates.xml");
    xmlTestSupport.assertValid("100valid_minimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_210invalid_duplicateId() {
    xmlTestSupport.assertInvalid("210invalid_duplicateId.xml");
    xmlTestSupport.assertValid("200valid_multiplePersons.xml");
  }

  @Test @Marking(points = 1)
  public void test_310invalid() {
    xmlTestSupport.assertInvalid("310invalid.xml");
    xmlTestSupport.assertValid("300valid_movie.xml");
  }

  @Test @Marking(points = 1)
  public void test_410invalid_name() {
    xmlTestSupport.assertInvalid("410invalid_name.xml");
    xmlTestSupport.assertValid("400valid_name.xml");
  }

  @Test @Marking(points = 1)
  public void test_420invalid_idNameToken() {
    xmlTestSupport.assertInvalid("420invalid_idNameToken.xml");
    xmlTestSupport.assertValid("400valid_name.xml");
  }

  @Test @Marking(points = 1)
  public void test_430invalid_requiredAttribs() {
    xmlTestSupport.assertInvalid("430invalid_requiredAttribs.xml");
    xmlTestSupport.assertValid("400valid_name.xml");
  }

  @Test @Marking(points = 1)
  public void test_440invalid_year() {
    xmlTestSupport.assertInvalid("440invalid_year.xml");
    xmlTestSupport.assertValid("400valid_name.xml");
  }

  @Test @Marking(points = 1)
  public void test_500valid_personBio() {
    xmlTestSupport.assertValid("500valid_personBio.xml");
  }

  @Test @Marking(points = 1)
  public void test_510invalid_idRequired() {
    xmlTestSupport.assertInvalid("510invalid_idRequired.xml");
    xmlTestSupport.assertValid("505valid_person.xml");
  }

  @Test @Marking(points = 1)
  public void test_610invalid_actorRef() {
    xmlTestSupport.assertInvalid("610invalid_actorRef.xml");
    xmlTestSupport.assertValid("600valid_personRef.xml");
  }

  @Test @Marking(points = 1)
  public void test_620invalid_directorRef() {
    xmlTestSupport.assertInvalid("620invalid_directorRef.xml");
    xmlTestSupport.assertValid("600valid_personRef.xml");
  }

  @Test @Marking(points = 1)
  public void test_630invalid_personRef() {
    xmlTestSupport.assertInvalid("630invalid_personRef.xml");
    xmlTestSupport.assertValid("600valid_personRef.xml");
  }

  @Test @Marking(points = 1)
  public void test_640invalid_uniqueCast() {
    xmlTestSupport.assertInvalid("640invalid_uniqueCast.xml");
    xmlTestSupport.assertValid("600valid_personRef.xml");
  }

  @Test @Marking(points = 1)
  public void test_710invalid_rating() {
    xmlTestSupport.assertInvalid("710invalid_rating.xml");
    xmlTestSupport.assertValid("700valid_rating.xml");
  }
}
