package de.hdm_stuttgart.mi.sda1.exam.xsd.test;

import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.exam.unitmarking.xml.XmlTestSupport;
import org.junit.Test;

/**
 * Unit test for an XML instance set.
 */
@SuppressWarnings({"UnusedDeclaration", "static-method"})
public class SchemaTest {

  private final XmlTestSupport xmlTestSupport = new XmlTestSupport("SchemaTest");

  @Test @Marking(points = 1)
  public void test_0115invalid_shortWithSpace() {
    xmlTestSupport.assertInvalid("0115invalid_shortWithSpace.xml");
    xmlTestSupport.assertValid("0100valid_minimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0120invalid_duplicateShort() {
    xmlTestSupport.assertInvalid("0120invalid_duplicateShort.xml");
    xmlTestSupport.assertValid("0100valid_minimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0125invalid_noShort() {
    xmlTestSupport.assertInvalid("0125invalid_noShort.xml");
    xmlTestSupport.assertValid("0100valid_minimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0130invalid_shortZeroLength() {
    xmlTestSupport.assertInvalid("0130invalid_shortZeroLength.xml");
    xmlTestSupport.assertValid("0100valid_minimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0140invalid_noDepartment() {
    xmlTestSupport.assertInvalid("0140invalid_noDepartment.xml");
    xmlTestSupport.assertValid("0100valid_minimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0145invalid_noName() {
    xmlTestSupport.assertInvalid("0145invalid_noName.xml");
    xmlTestSupport.assertValid("0100valid_minimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0150invalid_duplicateName() {
    xmlTestSupport.assertInvalid("0150invalid_duplicateName.xml");
    xmlTestSupport.assertValid("0100valid_minimum.xml");
  }

  @Test @Marking(points = 2)
  public void test_0210invalid_nestingDuplicateShort() {
    xmlTestSupport.assertInvalid("0210invalid_nestingDuplicateShort.xml");
    xmlTestSupport.assertValid("0200valid_nesting.xml");
  }

  @Test @Marking(points = 1)
  public void test_0305invalid_NoDepartment() {
    xmlTestSupport.assertInvalid("0305invalid_NoDepartment.xml");
    xmlTestSupport.assertValid("0300valid_minEmployee.xml");
  }

  @Test @Marking(points = 1)
  public void test_0310invalid_NoSsn() {
    xmlTestSupport.assertInvalid("0310invalid_NoSsn.xml");
    xmlTestSupport.assertValid("0300valid_minEmployee.xml");
  }

  @Test @Marking(points = 1)
  public void test_0315invalid_NoCommonName() {
    xmlTestSupport.assertInvalid("0315invalid_NoCommonName.xml");
    xmlTestSupport.assertValid("0300valid_minEmployee.xml");
  }

  @Test @Marking(points = 1)
  public void test_0325invalid_duplicateCommonName() {
    xmlTestSupport.assertInvalid("0325invalid_duplicateCommonName.xml");
    xmlTestSupport.assertValid("0300valid_minEmployee.xml");
  }

  @Test @Marking(points = 1)
  public void test_0410invalid_duplicateSsn() {
    xmlTestSupport.assertInvalid("0410invalid_duplicateSsn.xml");
    xmlTestSupport.assertValid("0400valid_multipleEmployee.xml");
  }
}