package de.hdm_stuttgart.mi.sda1.exam.xsd.test;

import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.exam.unitmarking.xml.XmlTestSupport;
import org.junit.Assert;
import org.junit.Test;

/**
 * Unit test for an XML instance set.
 */
public class SchemaTest {

  private final XmlTestSupport xmlTestSupport = new XmlTestSupport("SchemaTest");

  @Test @Marking(points = 1)
  public void test_0100valid_minimum() {
    xmlTestSupport.assertValid("0100valid_minimum.xml");
  }

  @Test @Marking(points = 3)
  public void test_0122invalid_inodeString() {
    xmlTestSupport.assertInvalid("0122invalid_inodeString.xml");
    xmlTestSupport.assertValid("0120valid_uniqueComponents.xml");
  }

  @Test @Marking(points = 2)
  public void test_0125invalid_missingName() {
    xmlTestSupport.assertInvalid("0125invalid_missingName.xml");
    xmlTestSupport.assertValid("0120valid_uniqueComponents.xml");
  }

  @Test @Marking(points = 2)
  public void test_0130invalid_missingInode() {
    xmlTestSupport.assertInvalid("0130invalid_missingInode.xml");
    xmlTestSupport.assertValid("0120valid_uniqueComponents.xml");
  }

  @Test @Marking(points = 2)
  public void test_0135invalid_missingTarget() {
    xmlTestSupport.assertInvalid("0135invalid_missingTarget.xml");
    xmlTestSupport.assertValid("0120valid_uniqueComponents.xml");
  }

  @Test @Marking(points = 2)
  public void test_0137invalid_targetNoexist() {
    xmlTestSupport.assertInvalid("0137invalid_targetNoexist.xml");
    xmlTestSupport.assertValid("0120valid_uniqueComponents.xml");
  }

  @Test @Marking(points = 2)
  public void test_0140invalid_duplicateObjectName() {
    xmlTestSupport.assertInvalid("0140invalid_duplicateObjectName.xml");
    xmlTestSupport.assertValid("0100valid_minimum.xml");
  }

  @Test @Marking(points = 2)
  public void test_0160invalid_duplicateInode() {
    xmlTestSupport.assertInvalid("0160invalid_duplicateInode.xml");
    xmlTestSupport.assertValid("0100valid_minimum.xml");
  }

  @Test @Marking(points = 2)
  public void test_0165invalid_uniqueComponentsOrder() {
    xmlTestSupport.assertInvalid("0165invalid_uniqueComponentsOrder.xml");
    xmlTestSupport.assertValid("0120valid_uniqueComponents.xml");
  }

  @Test @Marking(points = 3)
  public void test_0200invalid_hierarchyDuplicateInode() {
    xmlTestSupport.assertInvalid("0200invalid_hierarchyDuplicateInode.xml");
    xmlTestSupport.assertValid("0180valid_hierarchy.xml");
  }

  @Test @Marking(points = 3)
  public void test_0220invalid_hierarchyDuplicateName() {
    xmlTestSupport.assertInvalid("0220invalid_hierarchyDuplicateName.xml");
    xmlTestSupport.assertValid("0180valid_hierarchy.xml");
  }

  @Test @Marking(points = 3)
  public void test_0300invalid_hierarchyReference() {
    xmlTestSupport.assertInvalid("0300invalid_hierarchyReference.xml");
    xmlTestSupport.assertValid("0180valid_hierarchy.xml");
  }

  @Test @Marking(points = 3)
  public void test_0320invalid_hierarchyOrder() {
    xmlTestSupport.assertInvalid("0320invalid_hierarchyOrder.xml");
    xmlTestSupport.assertValid("0180valid_hierarchy.xml");
  }
}