DROP TABLE IF EXISTS Competition, Athlete;

CREATE TABLE Athlete (
   id INT NOT NULL PRIMARY KEY
  ,fullName CHAR(20) NOT NULL
);

CREATE TABLE Competition (
   id INT PRIMARY KEY
  ,athlete INT NOT NULL REFERENCES Athlete(id)
  ,time NUMERIC(6,2) NOT NULL
  ,badStart BOOLEAN NOT NULL
);

INSERT INTO Athlete VALUES(1, 'Jesse Owens');
INSERT INTO Athlete VALUES(2, 'Tim Culver');
INSERT INTO Athlete VALUES(3, 'Sid Gascoine');
INSERT INTO Athlete VALUES(4, 'John Hooker');
INSERT INTO Athlete VALUES(5, 'Brad Duncan');

/* 100 metre race */
INSERT INTO Competition VALUES(1, 1, 10.23, FALSE); /* Jesse Owens */
INSERT INTO Competition VALUES(2, 2, 11.55, FALSE); /* Tim Culver */
INSERT INTO Competition VALUES(3, 3, 11.94, FALSE); /* Sid Gascoine */
INSERT INTO Competition VALUES(4, 4, 10.02, FALSE); /* John Hooker */
INSERT INTO Competition VALUES(5, 5, 10.84, FALSE); /* Brad Duncan */
INSERT INTO Competition VALUES(6, 2, 10.02, FALSE); /* Tim Culver */
INSERT INTO Competition VALUES(7, 3, 10.49, FALSE); /* Sid Gascoine */
INSERT INTO Competition VALUES(8, 2,  9.35, TRUE); /* Tim Culver */

/* All runs including bad starts */
SELECT fullName, time, badStart
FROM Competition, Athlete
WHERE Competition.athlete = Athlete.id
ORDER BY time

/* Just the best valid run of each athlete */
SELECT fullName, min(time) AS time
FROM Competition, Athlete
WHERE Competition.athlete = Athlete.id
  AND NOT(badStart)
GROUP BY Athlete.id
ORDER BY time, fullName;
