package de.hdm_stuttgart.mi.sda1.impl;

import org.jdom2.Element;
import org.jdom2.output.Format;
import org.jdom2.output.XMLOutputter;

import java.io.IOException;
import java.io.OutputStream;
import java.sql.*;

abstract public class DbRead {

  abstract void addData()throws SQLException;

  protected Element html, table;

  protected Connection conn;

  public DbRead() {
    html = new Element("html");

    Connection connTmp = null;
    try {
      conn = DriverManager.getConnection(
          "jdbc:postgresql://localhost:5432/hdm", "hdmuser", "XYZ");
      table = addHeader();
      addData();
    } catch (final SQLException e) {
      System.err.println("Unable to establish connection: " + e);
      System.exit(1);
    }
  }

  public void toHtml(final OutputStream out) {

    final XMLOutputter printer =
        new XMLOutputter(Format.getPrettyFormat());
    try {
      printer.output(html, out);
    } catch (final IOException e) {
      System.err.println("Unable to write output: " + e);
    }
  }

  private Element addHeader() throws SQLException{

    html.addContent(new Element("head").addContent(new Element("title").addContent("Results")));

    final Element table =
        new Element(
            "table")
                         .addContent(new Element(
                             "tr").addContent(new Element("th").addContent("Rank"))
                                        .addContent(new Element("th").addContent("Name"))
                                        .addContent(new Element("th").addContent("Time")));

    html.addContent(table);

    return table;
  }
}




/*
*

  <body>
    <table>
      <tr style="background: red;">
        <td>1</td>
        <td>Tim Culver</td>
        <td>9.35</td>
      </tr>
   ...
    </table>
  </body>
  *
  *
*
*
*  */