package de.hdm_stuttgart.mi.sda1.test.ex1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.exam.unitmarking.xml.XmlTestSupport;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration"})
public class TestSchema extends ExaminationTestDefaults {

    private final XmlTestSupport xmlTestSupport = new XmlTestSupport("SchemaTest");

    @Test
    @Marking(points = 1)
    public void test_0100_valid_minimum() {
        xmlTestSupport.assertValid("0100_valid_minimum.xml");
    }

    @Test
    @Marking(points = 1)
    public void test_0200_valid_noPublisher() {
        xmlTestSupport.assertValid("0200_valid_noPublisher.xml");
    }

    @Test
    @Marking(points = 1)
    public void test_0210_valid_singlePublisher() {
        xmlTestSupport.assertValid("0210_valid_singlePublisher.xml");
    }

    @Test
    @Marking(points = 1)
    public void test_0230_valid_multiplePublisher() {
        xmlTestSupport.assertValid("0230_valid_multiplePublisher.xml");
    }

    @Test
    @Marking(points = 2)
    public void test_0240_invalid_duplicatePublisherId() {
        xmlTestSupport.assertInvalid("0240_invalid_duplicatePublisherId.xml");
        xmlTestSupport.assertValid("0230_valid_multiplePublisher.xml");
    }

    @Test
    @Marking(points = 2)
    public void test_0250_invalid_duplicatePublisherNameCity() {
        xmlTestSupport.assertInvalid("0250_invalid_duplicatePublisherNameCity.xml");
        xmlTestSupport.assertValid("0230_valid_multiplePublisher.xml");
    }

    @Test
    @Marking(points = 2)
    public void test_0260_invalid_publisherLevel() {
        xmlTestSupport.assertInvalid("0260_invalid_publisherLevel.xml");
        xmlTestSupport.assertValid("0230_valid_multiplePublisher.xml");
    }

    @Test
    @Marking(points = 1)
    public void test_0300_valid_books() {
        xmlTestSupport.assertValid("0300_valid_books.xml");
    }

    @Test
    @Marking(points = 2)
    public void test_0310_invalid_bookNoTitle() {
        xmlTestSupport.assertInvalid("0310_invalid_bookNoTitle.xml");
        xmlTestSupport.assertValid("0300_valid_books.xml");
    }

    @Test
    @Marking(points = 2)
    public void test_0320_invalid_bookNoAuthor() {
        xmlTestSupport.assertInvalid("0320_invalid_bookNoAuthor.xml");
        xmlTestSupport.assertValid("0300_valid_books.xml");
    }

    @Test
    @Marking(points = 1)
    public void test_0400_valid_websites() {
        xmlTestSupport.assertValid("0400_valid_websites.xml");
    }

    @Test
    @Marking(points = 2)
    public void test_0410_invalid_websiteDateViolation() {
        xmlTestSupport.assertInvalid("0410_invalid_websiteDateViolation.xml");
        xmlTestSupport.assertValid("0400_valid_websites.xml");
    }

    @Test
    @Marking(points = 2)
    public void test_0420_invalid_websiteMissingAccessDate() {
        xmlTestSupport.assertInvalid("0420_invalid_websiteMissingAccessDate.xml");
        xmlTestSupport.assertValid("0400_valid_websites.xml");
    }

    @Test
    @Marking(points = 2)
    public void test_0430_invalid_websiteMissingUrl() {
        xmlTestSupport.assertInvalid("0430_invalid_websiteMissingUrl.xml");
        xmlTestSupport.assertValid("0400_valid_websites.xml");
    }

    @Test
    @Marking(points = 2)
    public void test_0440_invalid_websiteUrlFormatViolation() {
        xmlTestSupport.assertInvalid("0440_invalid_websiteUrlFormatViolation.xml");
        xmlTestSupport.assertValid("0400_valid_websites.xml");
    }

    @Test
    @Marking(points = 1)
    public void test_0500_valid_booksWebsites() {
        xmlTestSupport.assertValid("0500_valid_booksWebsites.xml");
    }

    @Test
    @Marking(points = 1)
    public void test_0510_invalid_bookDuplicateId() {
        xmlTestSupport.assertInvalid("0510_invalid_bookDuplicateId.xml");
        xmlTestSupport.assertValid("0500_valid_booksWebsites.xml");
    }

    @Test
    @Marking(points = 1)
    public void test_0515_invalid_bookYear() {
        xmlTestSupport.assertInvalid("0515_invalid_bookYear.xml");
        xmlTestSupport.assertValid("0500_valid_booksWebsites.xml");
    }

    @Test
    @Marking(points = 1)
    public void test_0520_invalid_bibDuplicateId() {
        xmlTestSupport.assertInvalid("0520_invalid_bibDuplicateId.xml");
        xmlTestSupport.assertValid("0500_valid_booksWebsites.xml");
    }

    @Test
    @Marking(points = 1)
    public void test_0600_invalid_bookInvalidPublisher() {
        xmlTestSupport.assertInvalid("0600_invalid_bookInvalidPublisher.xml");
        xmlTestSupport.assertValid("0300_valid_books.xml");
    }

    @Test
    @Marking(points = 1)
    public void test_0700_valid_bibPublisherIdCompat() {
        xmlTestSupport.assertValid("0700_valid_bibPublisherIdCompat.xml");
    }
}
