DROP TABLE IF EXISTS Para, Section;

-- TODO
-- Read the exercise's documentation and add your schema here. You may
-- re-use subsequent INSERT statements or adapt them to your schema.

CREATE TABLE Section(

    id CHAR(255) NOT NULL PRIMARY KEY,
    title VARCHAR(255) NOT NULL,
    parent CHAR(255) NULL REFERENCES Section,
    revisionflag CHAR(7) NULL,
    orderNo INT NOT NULL GENERATED ALWAYS AS IDENTITY UNIQUE,
    CHECK(revisionflag IN ('new', 'changed', 'deleted'))
);

CREATE TABLE Para (
    parent CHAR(255) NOT NULL REFERENCES Section,
    para TEXT,
    revisionflag CHAR(7) NULL,
    orderNo INT NOT NULL GENERATED ALWAYS AS IDENTITY UNIQUE,
    CHECK(revisionflag IN ('new', 'changed', 'deleted'))
);

INSERT INTO  Section (id, title, parent, revisionflag) VALUES ('categories', 'XML Document categories', NULL, 'new');
INSERT INTO  Section (id, title, parent, revisionflag) VALUES ('wellFormed', 'Well-formed documents',  'categories' ,NULL);

INSERT INTO  Para (parent, para, revisionflag) VALUES (
  'categories', 'Documents belonging to this category do not adhere to any schema.','changed');


INSERT INTO  Section (id, title, parent, revisionflag) VALUES ('valid', 'Valid documents',  'categories',          NULL);
INSERT INTO  Para (parent, para, revisionflag) VALUES ('valid', 'Valid documents require a schema.',          'changed');
INSERT INTO  Para (parent, para, revisionflag) VALUES ('valid', 'Common standards are DTD, XML Schema and Relax-NG.',NULL);

INSERT INTO  Section (id, title, parent, revisionflag) VALUES ('api', 'Available APIs', NULL,                       'deleted');
INSERT INTO  Para (parent, para, revisionflag) VALUES    ('api', 'We introduce SAX and DOM here.',             NULL);
INSERT INTO  Para(parent, para, revisionflag)  VALUES    ('api', 'Some APIs offer multiple language bindings.', NULL);

SELECT * FROM Section;



SELECT * FROM Para;
