package de.hdm_stuttgart.mi.sda1.test.ex1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.exam.unitmarking.xml.XmlTestSupport;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

/**
 * Unit test for an XML instance set. CLI by:
 * java -cp target/solvejpa-0.9-fat-tests.jar org.junit.runner.JUnitCore SchemaTest
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings("static-method")
public class SchemaTest extends ExaminationTestDefaults {

  private final XmlTestSupport xmlTestSupport = new XmlTestSupport("SchemaTest");

  @Test @Marking(points = 1)
  public void test_0100validMinimum() {
    xmlTestSupport.assertValid("0100validMinimum.xml");
  }

  @Test @Marking(points = 2)
  public void test_0103__invalidMissingIdAttribute() {
    xmlTestSupport.assertInvalid("0103__invalidMissingIdAttribute.xml");
    xmlTestSupport.assertValid("0100validMinimum.xml");
  }

  @Test @Marking(points = 2)
  public void test_0105__invalidEmptyIdValue() {
    xmlTestSupport.assertInvalid("0105__invalidEmptyIdValue.xml");
    xmlTestSupport.assertValid("0100validMinimum.xml");
  }

  @Test @Marking(points = 2)
  public void test_0110__invalidMissingBookTitle() {
    xmlTestSupport.assertInvalid("0110__invalidMissingBookTitle.xml");
    xmlTestSupport.assertValid("0100validMinimum.xml");
  }

  @Test @Marking(points = 2)
  public void test_0115__invalidMissingSectionTitle() {
    xmlTestSupport.assertInvalid("0115__invalidMissingSectionTitle.xml");
    xmlTestSupport.assertValid("0100validMinimum.xml");
  }

  @Test @Marking(points = 2)
  public void test_0120__invalidMissingParaOrSection() {
    xmlTestSupport.assertInvalid("0120__invalidMissingParaOrSection.xml");
    xmlTestSupport.assertValid("0100validMinimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0125__invalidNoSection() {
    xmlTestSupport.assertInvalid("0125__invalidNoSection.xml");
    xmlTestSupport.assertValid("0100validMinimum.xml");
  }

  @Test @Marking(points = 2)
  public void test_0130__invalidDuplicateId() {
    xmlTestSupport.assertInvalid("0130__invalidDuplicateId.xml");
    xmlTestSupport.assertValid("0100validMinimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0200validRevision() {
    xmlTestSupport.assertValid("0200validRevision.xml");
  }

  @Test @Marking(points = 2)
  public void test_0203__invalidBookNoRevision() {
    xmlTestSupport.assertInvalid("0203__invalidBookNoRevision.xml");
    xmlTestSupport.assertValid("0200validRevision.xml");
  }

  @Test @Marking(points = 2)
  public void test_0205__invalidBookTitleNoRevision() {
    xmlTestSupport.assertInvalid("0205__invalidBookTitleNoRevision.xml");
    xmlTestSupport.assertValid("0200validRevision.xml");
  }

  @Test @Marking(points = 2)
  public void test_0210__invalidSectionTitleNoRevision() {
    xmlTestSupport.assertInvalid("0210__invalidSectionTitleNoRevision.xml");
    xmlTestSupport.assertValid("0200validRevision.xml");
  }

  @Test @Marking(points = 2)
  public void test_0215__invalidRevisionValue() {
    xmlTestSupport.assertInvalid("0215__invalidRevisionValue.xml");
    xmlTestSupport.assertValid("0200validRevision.xml");
  }

  @Test @Marking(points = 1)
  public void test_0300validNestedSections() {
    xmlTestSupport.assertValid("0300validNestedSections.xml");
  }

  @Test @Marking(points = 2)
  public void test_0305__invalidParaAfterSection() {
    xmlTestSupport.assertInvalid("0305__invalidParaAfterSection.xml");
    xmlTestSupport.assertValid("0300validNestedSections.xml");
  }

  @Test @Marking(points = 2)
  public void test_0310__invalidNestedDuplicateId() {
    xmlTestSupport.assertInvalid("0310__invalidNestedDuplicateId.xml");
    xmlTestSupport.assertValid("0300validNestedSections.xml");
  }

  @Test @Marking(points = 2)
  public void test_0315__invalidWrongSectionTitleOrder() {
    xmlTestSupport.assertInvalid("0315__invalidWrongSectionTitleOrder.xml");
    xmlTestSupport.assertValid("0300validNestedSections.xml");
  }

}