DROP TABLE IF EXISTS Para, Section;

CREATE TABLE Section (
   id           VARCHAR(255) PRIMARY KEY
  ,title        TEXT         NOT NULL
  ,parent       VARCHAR(255) NULL     REFERENCES Section(id)
  ,revisionFlag CHAR(7)      NULL
  ,orderValue   INT          NOT NULL GENERATED ALWAYS AS IDENTITY UNIQUE

  ,CHECK (revisionFlag in ('new', 'changed', 'deleted'))
);

CREATE TABLE Para (
   section VARCHAR(100) NOT NULL REFERENCES Section
  ,para TEXT            NOT NULL
  ,revisionFlag CHAR(7) NULL
  ,orderValue INT       NOT NULL GENERATED ALWAYS AS IDENTITY UNIQUE
  ,CHECK ( revisionFlag in ('new', 'changed', 'deleted'))
);

INSERT INTO  Section (id, title, parent, revisionFlag) VALUES ('categories', 'XML Document categories', NULL,        'new');
INSERT INTO  Section (id, title, parent, revisionFlag) VALUES ('wellFormed', 'Well-formed documents',   'categories', NULL);
INSERT INTO  Section (id, title, parent, revisionFlag) VALUES ('valid',      'Valid documents',         'categories', NULL);
INSERT INTO  Section (id, title, parent, revisionFlag) VALUES ('api',        'Available APIs',          NULL,         'deleted');

INSERT INTO  Para (section, para, revisionFlag) VALUES
('categories', 'Documents belonging to this category do not adhere to any schema.','changed');

INSERT INTO  Para  (section, para, revisionFlag) VALUES
('valid',      'Valid documents require a schema.',                                 'changed');

INSERT INTO  Para  (section, para, revisionFlag) VALUES
('valid',      'Common standards are DTD, XML Schema and Relax-NG.',                NULL);

INSERT INTO  Para (section, para, revisionFlag)  VALUES
('api',        'We introduce SAX and DOM here.',                                    NULL);

INSERT INTO  Para  (section, para, revisionFlag) VALUES
('api',        'Some APIs offer multiple language bindings.',                       NULL);

SELECT * FROM Section;
SELECT * FROM Para;
