package de.hdm_stuttgart.mi.sda1;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.jdom2.*;
import org.jdom2.input.SAXBuilder;

import java.io.File;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

public class Category2Rdbms implements AutoCloseable {

  static private final Logger log = LogManager.getLogger(Category2Rdbms.class);

  private Connection conn;

  private Element catalog;

  public Category2Rdbms() {
    try {
      conn = DriverManager.getConnection(
          "jdbc:postgresql://localhost/hdm", "hdmuser", "XYZ");
      log.info("Database connected? " + ! conn.isClosed());
    } catch (final SQLException e) {
      log.error("Unable to establish connection, exiting", e);
      System.exit(1);
    }


    final SAXBuilder builder = new SAXBuilder();
    try {
      catalog = builder.build(new File("Schema/sampledata.xml")).getRootElement();
    } catch (final JDOMException e) {
      log.error("Unable to parse input, exiting", e);
      System.exit(1);
    } catch (final IOException e) {
      log.error("Unable to read input, exiting", e);
      System.exit(1);
    }
  }

  public void execute() {
    log.info("Processing XML input file, producing sample output");
    catalog.getChild("categories").
        getChildren("category").
        stream().map(c -> c.getValue()).
        forEach(System.out::println);
  }

  @Override
  public void close() {
    try {
      conn.close();
    } catch (final SQLException e) {
      e.printStackTrace();
    }
  }
}