package de.hdm_stuttgart.mi.sda1.test.ex1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.exam.unitmarking.xml.XmlTestSupport;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

/**
 * Generated by de.hdm_stuttgart.mi.unitmarking.xsd.GenerateUnitTestClass
 *
 * Unit test for an XML instance set. CLI by:
 * java -cp target/...-fat-tests.jar org.junit.runner.JUnitCore SchemaTest
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings("static-method")
public class SchemaTest extends ExaminationTestDefaults {

  private final XmlTestSupport xmlTestSupport = new XmlTestSupport("SchemaTest");

  @Test @Marking(points = 1)
  public void test_0100validMinimum() {
    xmlTestSupport.assertValid("0100validMinimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0101_duplicateArticles() {
    xmlTestSupport.assertInvalid("0101_duplicateArticles.xml");
    xmlTestSupport.assertValid("0100validMinimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0101_duplicateCategories() {
    xmlTestSupport.assertInvalid("0101_duplicateCategories.xml");
    xmlTestSupport.assertValid("0100validMinimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0101_missingArticles() {
    xmlTestSupport.assertInvalid("0101_missingArticles.xml");
    xmlTestSupport.assertValid("0100validMinimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0101_missingCategories() {
    xmlTestSupport.assertInvalid("0101_missingCategories.xml");
    xmlTestSupport.assertValid("0100validMinimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0110validSingleCategory() {
    xmlTestSupport.assertValid("0110validSingleCategory.xml");
  }

  @Test @Marking(points = 2)
  public void test_0111_invalid_EmptyIdValue() {
    xmlTestSupport.assertInvalid("0111_invalid_EmptyIdValue.xml");
    xmlTestSupport.assertValid("0110validSingleCategory.xml");
  }

  @Test @Marking(points = 2)
  public void test_0111_invalid_missing_id() {
    xmlTestSupport.assertInvalid("0111_invalid_missing_id.xml");
    xmlTestSupport.assertValid("0110validSingleCategory.xml");
  }

  @Test @Marking(points = 1)
  public void test_0111_invalid_whitespaceInId() {
    xmlTestSupport.assertInvalid("0111_invalid_whitespaceInId.xml");
    xmlTestSupport.assertValid("0110validSingleCategory.xml");
  }

  @Test @Marking(points = 1)
  public void test_0120validMultiCategory() {
    xmlTestSupport.assertValid("0120validMultiCategory.xml");
  }

  @Test @Marking(points = 2)
  public void test_0121_invalidDuplicateCategoryId() {
    xmlTestSupport.assertInvalid("0121_invalidDuplicateCategoryId.xml");
    xmlTestSupport.assertValid("0120validMultiCategory.xml");
  }

  @Test @Marking(points = 1)
  public void test_0150validMinimumArticle() {
    xmlTestSupport.assertValid("0150validMinimumArticle.xml");
  }

  @Test @Marking(points = 2)
  public void test_0151_invalidMissingOrderNo() {
    xmlTestSupport.assertInvalid("0151_invalidMissingOrderNo.xml");
    xmlTestSupport.assertValid("0150validMinimumArticle.xml");
  }

  @Test @Marking(points = 1)
  public void test_0151_invalidNegativeOrderNo() {
    xmlTestSupport.assertInvalid("0151_invalidNegativeOrderNo.xml");
    xmlTestSupport.assertValid("0150validMinimumArticle.xml");
  }

  @Test @Marking(points = 1)
  public void test_0151_invalidZeroOrderNo() {
    xmlTestSupport.assertInvalid("0151_invalidZeroOrderNo.xml");
    xmlTestSupport.assertValid("0150validMinimumArticle.xml");
  }

  @Test @Marking(points = 1)
  public void test_0160validFullArticle() {
    xmlTestSupport.assertValid("0160validFullArticle.xml");
  }

  @Test @Marking(points = 1)
  public void test_0161_invalidDuplicateDescription() {
    xmlTestSupport.assertInvalid("0161_invalidDuplicateDescription.xml");
    xmlTestSupport.assertValid("0160validFullArticle.xml");
  }

  @Test @Marking(points = 2)
  public void test_0161_invalidMissingSource() {
    xmlTestSupport.assertInvalid("0161_invalidMissingSource.xml");
    xmlTestSupport.assertValid("0160validFullArticle.xml");
  }

  @Test @Marking(points = 1)
  public void test_0161_invalidMissingType() {
    xmlTestSupport.assertInvalid("0161_invalidMissingType.xml");
    xmlTestSupport.assertValid("0160validFullArticle.xml");
  }

  @Test @Marking(points = 1)
  public void test_0161_invalidWrongImgType() {
    xmlTestSupport.assertInvalid("0161_invalidWrongImgType.xml");
    xmlTestSupport.assertValid("0160validFullArticle.xml");
  }

  @Test @Marking(points = 2)
  public void test_02001_invalidDanglingReference() {
    xmlTestSupport.assertInvalid("02001_invalidDanglingReference.xml");
    xmlTestSupport.assertValid("0200validTwoArticles.xml");
  }

  @Test @Marking(points = 1)
  public void test_02001_invalidDuplicateCat() {
    xmlTestSupport.assertInvalid("02001_invalidDuplicateCat.xml");
    xmlTestSupport.assertValid("0200validTwoArticles.xml");
  }

  @Test @Marking(points = 1)
  public void test_02001_invalidMissingCatRef() {
    xmlTestSupport.assertInvalid("02001_invalidMissingCatRef.xml");
    xmlTestSupport.assertValid("0200validTwoArticles.xml");
  }

  @Test @Marking(points = 1)
  public void test_0200validTwoArticles() {
    xmlTestSupport.assertValid("0200validTwoArticles.xml");
  }
}