DROP TABLE IF EXISTS Category2Article, Article, Category;

CREATE TABLE Category
(
    id    VARCHAR(255) PRIMARY KEY,
    title TEXT NOT NULL
);

CREATE TABLE Article
(
    orderNo     INT          NOT NULL CHECK (0 < orderNo) PRIMARY KEY,

    name        TEXT         NOT NULL,
    description TEXT         NULL,

    img         VARCHAR(255) NULL,
    imgType     CHAR(3)      NULL CHECK ((imgType ISNULL) OR (imgType IN ('png', 'gif', 'svg'))), /* better use enum? */

    CONSTRAINT imageNameAndTypeInSync
        CHECK ( (img IS NOT NULL AND imgType IS NOT NULL) OR
                (img ISNULL AND imgType ISNULL) )
);

CREATE TABLE Category2Article
(
    category VARCHAR(255) NOT NULL REFERENCES Category,
    orderNo  INT          NOT NULL REFERENCES Article,
    PRIMARY KEY (category, orderNo)
);

/* Inserting categories */
INSERT INTO Category
VALUES ('food', 'Food and drinking');

INSERT INTO Category
VALUES ('hardware', 'Tools, DIY');

INSERT INTO Category
VALUES ('lifestyle', 'Lifestyle products');


/* Inserting articles */
INSERT INTO Article
VALUES (232434, 'Super 3D Tin Lunch Box', NULL, '232434_1', 'png');

INSERT INTO Article
VALUES (544343, 'Monthly beer subscription box', 'Various brands and flavours on offer.', NULL, NULL);

/* Relating categories and articles */
INSERT INTO Category2Article
VALUES ('lifestyle', 232434);

INSERT INTO Category2Article
VALUES ('hardware', 232434);

INSERT INTO Category2Article
VALUES ('food', 544343);

SELECT * FROM Category;
SELECT * FROM Article;
SELECT * FROM Category2Article;