package de.hdm_stuttgart.mi.sda1.sql2catalog;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.jdom2.Element;

/**
 * Reading product data
 *
 */
public class RdbmsAccess {
	
	final PreparedStatement selectStudyCourses, selectStudents;

	/**
	 * @param conn Destination RDBMS
	 * @throws SQLException 
	 */
	public RdbmsAccess(final Connection conn) throws SQLException {
	   conn.setAutoCommit(false);
	   selectStudyCourses = conn.prepareStatement("SELECT * FROM StudyCourse");
	   selectStudents = conn.prepareStatement("SELECT * FROM Student");
	}
	
   public void appendStudyCourses(final Element parent) throws SQLException {
      final ResultSet studyCourses = selectStudyCourses.executeQuery();
      
      while (studyCourses.next()) {
         final Element studyCourse = new Element("studyCourse");
         parent.addContent(studyCourse);
         studyCourse.setAttribute("id", "" + studyCourses.getInt("id"))
                    .addContent(new Element("name").setText(studyCourses.getString("name")));
         final String bachelorMaster = studyCourses.getString("program");
         if (null != bachelorMaster) {
        	 studyCourse.setAttribute("program",bachelorMaster);
         }
         final String shortName = studyCourses.getString("shortName");
         if (!studyCourses.wasNull()){
            studyCourse.addContent(new Element("shortName").setText(shortName));
         }
      }
      studyCourses.close();
   }
   
   public void appendStudents(final Element parent) throws SQLException {
      final ResultSet students = selectStudents.executeQuery();
      
      while (students.next()) {
         final Element student = new Element("student");
         parent.addContent(student);
         student.setAttribute("id", "" + students.getInt("id"))
                .addContent(new Element("fullName").setText(students.getString("fullName")))
                .addContent(new Element("email").setText(students.getString("email")))
                    ;
         final int studyCourse = students.getInt("studyCourse");
         if (!students.wasNull()){
            student.setAttribute("studyCourse", "" + studyCourse);
         }
      }
      students.close();
   }
}
