package de.hdm_stuttgart.mi.sda2.catalog;

import java.io.File;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;

import de.hdm_stuttgart.mi.sda2.catalog.jaxb.Article;
import de.hdm_stuttgart.mi.sda2.catalog.jaxb.Group;
import de.hdm_stuttgart.mi.sda2.catalog.jaxb.ProductGroups;

/**
 * Loading objects from XML file based data
 * 
 */
public class LoadXml {

   /**
    * @param args Unused
    * @throws JAXBException 
    */
   @SuppressWarnings("javadoc")
   public static void main(String[] args) throws JAXBException {

      final JAXBContext cdContext = JAXBContext.newInstance("de.hdm_stuttgart.mi.sda2.catalog.jaxb");
      final Unmarshaller u = cdContext.createUnmarshaller();
      final ProductGroups productGroups= (ProductGroups) u.unmarshal(new File("XmlData/samplegroups.xml"));

      System.out.println(productGroups.getGroup().size() + " product group(s):");
      for (final Group g : productGroups.getGroup()) {
         System.out.println("Group title:" + g.getTitle() + " containing " + g.getArticle().size() + " article(s)");
         
         for (Article a : g.getArticle()) {
            System.out.println( "Article no. " + a.getProductNumber());
         }
         System.out.println("----------------");
      }
   }
}
