package de.hdm_stuttgart.mi.sda2.catalog.domain;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;


/**
 * Products of a supermarket group
 *
 */
@Entity 
@Inheritance(strategy=InheritanceType.JOINED)
@SuppressWarnings("javadoc")
public abstract class Product {
   
   @Id
   @GeneratedValue(strategy=GenerationType.IDENTITY)
   Long id;
   
   @Column(unique=true, nullable=false)
   int productNumber;
   
   String name; // e.g. "Tennis racket"
   
   @ManyToOne(cascade=CascadeType.ALL)
   @JoinColumn(nullable=true)
   ProductProvider primaryProvider;

   protected Product() {}
   
   public Product(int productNumber, String name) {
      setProductNumber(productNumber);
      setName(name);
   }

   public int getProductNumber() {
      return productNumber;
   }

   public void setProductNumber(int productNumber) {
      this.productNumber = productNumber;
   }

   public String getName() {
      return name;
   }

   public void setName(String name) {
      this.name = name;
   }

   public Long getId() {
      return id;
   }

   public ProductProvider getPrimaryProvider() {
      return primaryProvider;
   }

   protected void setPrimaryProvider(ProductProvider primaryProvider) {
      this.primaryProvider = primaryProvider;
   }

   @Override
   public String toString() {
      return ", productNo. =" + getProductNumber() + ", id=" + getId();
   }
   
}
