package de.hdm_stuttgart.mi.sd1.stringarray2html;

/**
 * Converting array values to HTML.
 *
 */
public class Stringarray2Html {
  
  /**
   * Create an unordered &lt;ul&gt; ... &lt;/ul&gt; html list from a given array of strings
   * and provide a &lt;li&gt; ... &lt;/li&gt; item for each array string.
   * 
   * Thus an array like e.g. {"England", "France", "Germany"} is to be transformed to:
   * 
   * <pre>&lt;ul&gt;
  &lt;li&gt;England&lt;/li&gt;
  &lt;li&gt;France&lt;/li&gt;
  &lt;li&gt;Germany&lt;/li&gt;
&lt;/ul&gt;</pre>
   * 
   * 
   * @param strings
   *  The list of values to be embedded into an unordered HTML list or null
   * 
   * @return
   *  The HTML unordered list containing one element per array value. In case the input array is void
   *  or null an empty string "" will be returned.
   */
  static public String strings2html(final String [] strings) {

    if (null == strings || 0 == strings.length) {
      return "";
    } else {

      final StringBuffer ret = new StringBuffer();

      ret.append("<ul>\n");

      for (final String s: strings) {
        ret.append("  <li>").append(s).append("</li>\n");
      }
      ret.append("</ul>");
      return ret.toString();
    } 
  }
}