package de.hdm_stuttgart.mi.sd1.fraction;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.api.Test;

import de.hdm_stuttgart.mi.sd1.store.BoundedIntegerStore;

@SuppressWarnings({"UnusedDeclaration", "javadoc"})
public class IntStoreTest {
  
  @Test
  public void testPositiveNegative() {
    final int capacity = 4;
    BoundedIntegerStore store = new BoundedIntegerStore(capacity);
    
    
    assertEquals(capacity, store.getCapacity()); // The store's capacity
    assertEquals(0, store.getNumValues());       // Store is initially empty
    
    final int v1 = -17, v2 = 3, v3 = -4;

    store.addValue(v1);                     // Add a single value 
    assertEquals(1, store.getNumValues());  // Store contains one value
    assertEquals(v1, store.getValue(0));    // Value should be present at index 0
    
    store.addValue(v2);                     // Add two more values
    store.addValue(v3);
    
    assertEquals(3, store.getNumValues());  // Store contains three values
    assertEquals(v1, store.getValue(0));    // Retrieve all values
    assertEquals(v2, store.getValue(1));
    assertEquals(v3, store.getValue(2));
  }
}
