package de.hdm_stuttgart.mi.marking;

import de.hdm_stuttgart.mi.marking.implement.MarkFrequencies;
import org.junit.Assert;
import org.junit.Test;

/**
 * Marking overview generation tests.
 */
@SuppressWarnings({"UnusedDeclaration"})
public class MarksTest {

  @Test
  public void testSingle() {

    final MarkFrequencies frequencies = new MarkFrequencies(new int[]{-3});

    Assert.assertEquals(-3, frequencies.lowestMark);

    Assert.assertArrayEquals(new int[]{1}, frequencies.frequencyByMark);
  }

  @Test
  public void testMultiple() {

    final MarkFrequencies frequencies = new MarkFrequencies(new int[]{-3, 4 , 2, -2, 4, -3, 2, 4});

    Assert.assertEquals(-3, frequencies.lowestMark);

    Assert.assertArrayEquals(new int[]{2, 1, 0, 0, 0, 2, 0, 3}, frequencies.frequencyByMark);
  }

  @Test
  public void testMultipleCommonValue() {

    final MarkFrequencies frequencies = new MarkFrequencies(new int[]{-1, -1, -1, -1, -1, -1});

    Assert.assertEquals(-1, frequencies.lowestMark);

    Assert.assertArrayEquals(new int[]{6}, frequencies.frequencyByMark);
  }

  /**
   *
   */
  @Test
  public void testEmptyCenter() {

    final MarkFrequencies frequencies = new MarkFrequencies(new int[]{-4, 2, 2, -4, 2, 2, -4});

    Assert.assertEquals(-4, frequencies.lowestMark);

    Assert.assertArrayEquals(new int[]{3, 0, 0, 0, 0, 0, 4}, frequencies.frequencyByMark);
  }
}