package de.hdm_stuttgart.mi.sd1.store;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertArrayEquals;
import static org.junit.jupiter.api.Assertions.assertTrue;

import org.junit.jupiter.api.Test;

import de.hdm_stuttgart.mi.sd1.statistics.main.ErrorState;
import de.hdm_stuttgart.mi.sd1.statistics.main.InputValidator;

@SuppressWarnings({"UnusedDeclaration", "javadoc"})
public class TestValidation {

  @Test
  public void testNoUserInput() {
    final InputValidator inputValidate = new InputValidator(new String[]{});
    assertEquals(ErrorState.NO_VALUE, inputValidate.getErrorState());
    assertTrue(null != inputValidate.getErrorMessage());
  }
  
  @Test
  public void testOneValidArgument() {
    final InputValidator inputValidate = new InputValidator(new String[]{"1"});
    assertEquals(ErrorState.OK, inputValidate.getErrorState());
    assertTrue(null == inputValidate.getErrorMessage());
    assertArrayEquals(new int[]{1}, inputValidate.values);
  }
  
  @Test
  public void testMultipleValidArguments() {
    final InputValidator inputValidate = new InputValidator(new String[]{"1", "-5", "107", "-1132"});
    assertEquals(ErrorState.OK, inputValidate.getErrorState());
    assertTrue(null == inputValidate.getErrorMessage());
    assertArrayEquals(new int[]{1, -5, 107, -1132}, inputValidate.values);
  }
  
  @Test
  public void testMultipleInvalidArguments() {
    final InputValidator inputValidate = new InputValidator(new String[]{"1", "-5", "seven", "-1132"});
    assertEquals(ErrorState.NO_INTEGER, inputValidate.getErrorState());
    assertTrue(null != inputValidate.getErrorMessage());
  }
}
