package de.hdm_stuttgart.mi.sd1.binomial.test;

import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.sd1.binomial.Binomial;

@SuppressWarnings({"UnusedDeclaration"})
public class BinomTest {

  @Test
  public void test_0_0() {
    Assert.assertEquals(1, Binomial.binomial(0, 0));
  }
  
  @Test
  public void test_1_0() {
    Assert.assertEquals(1, Binomial.binomial(1, 0));
  }
  
  @Test
  public void test_1_1() {
    Assert.assertEquals(1, Binomial.binomial(1, 1));
  }
  
  @Test
  public void test_4_3() {
    Assert.assertEquals(4, Binomial.binomial(4, 3));
  }
  
  @Test
  public void test_5_3() {
    Assert.assertEquals(10, Binomial.binomial(5, 3));
  }
  
  @Test
  public void test_20_20() {
    Assert.assertEquals(1, Binomial.binomial(20, 20));
  }

  // Possible arithmetic overflow situations.
  @Test
  public void test_22_1() {
    Assert.assertEquals(22, Binomial.binomial(22, 1));
  }

  @Test
  public void test_22_21() {
    Assert.assertEquals(22, Binomial.binomial(22, 21));
  }

  @Test
  public void test_22_2() {
    Assert.assertEquals(231, Binomial.binomial(22, 2));
  }

  @Test
  public void test_22_20() {
    Assert.assertEquals(231, Binomial.binomial(22, 20));
  }
}
