package de.hdm_stuttgart.mi.sd1.filepath;

import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.sd1.navigation.Segment;

/**
 * OS dependent tests see
 * https://www.thekua.com/atwork/2008/09/running-tests-on-a-specific-os-under-junit4/
 */
@SuppressWarnings({"UnusedDeclaration"})
public class NavigationTest {
   
   /** No legs at all. Testing for sake of consistency */
   @Test
   public void testVoid() {
      final Segment[] route = new Segment[] {};
      Assert.assertEquals(0, Segment.duration(route, 120));
   }
      
   /** One leg without any speed limit */
   @Test
   public void testSingle1() {
      final Segment[] route = new Segment[] { new Segment(10., 0)};
      Assert.assertEquals(5, Segment.duration(route, 120));
   }

   /** One leg with speed limit above user's personal limit */
   @Test
   public void testSingle2() {
      final Segment[] route = new Segment[] { new Segment(10., 140)};
      Assert.assertEquals(5, Segment.duration(route, 120));
   }

   /** One leg with speed limit below user's personal limit */
   @Test
   public void testSingle3() {
      final Segment[] route = new Segment[] { new Segment(10., 60)};
      Assert.assertEquals(10, Segment.duration(route, 120));
   }

   /** four legs including one without any speed limit */
   @Test
   public void test_3_1() {
      final Segment[] route = new Segment[] {
            new Segment(2.4, 50)
            ,new Segment(5, 100)
            ,new Segment(3.1, 0)
            ,new Segment(0.8, 30)
      };
      Assert.assertEquals(9, Segment.duration(route, 140));
   }
}
