package de.hdm_stuttgart.mi.sd1;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.sd1.LengthCompare;

@SuppressWarnings({"UnusedDeclaration", "javadoc"})
public class TestOrder {

  @Test
  public void testReadFileOk() {
    final List<String> expectedOrder =
        Arrays.asList(new String[]{
            "by", "it", "ant", "eye", "van", "apple", "x-ray", "printer"
        });
    
    final List<String> initiallyAlphabetOrder =
        Arrays.asList(new String[]{
             "ant", "apple", "by", "eye", "it", "printer", "van", "x-ray"
        });

    // Lists contain the same elements but in different order
    Assert.assertTrue(!expectedOrder.equals(initiallyAlphabetOrder));
    
    Collections.sort(initiallyAlphabetOrder, new LengthCompare());
    
    // By now our list should have been re-ordered accordingly.
    Assert.assertTrue(expectedOrder.equals(initiallyAlphabetOrder));
  }
}
