package de.hdm_stuttgart.mi.sd1.connectfour;

import static de.hdm_stuttgart.mi.sd1.tictactoe.Player.YOU;
import static de.hdm_stuttgart.mi.sd1.tictactoe.Player.COM;

import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.sd1.tictactoe.Board;
import de.hdm_stuttgart.mi.sd1.tictactoe.Player;
/**
 * Testing Tic-tac-toe.
 */
@SuppressWarnings({"UnusedDeclaration"})
public class PerfectMoveTest {

  @Test
  public void testWinningMove() {

    final Board board = new Board(
        COM,                      // active player.

        new Player[] {
            null,  COM,   YOU,    //  |X|O
            //                       -+-+-
            null,  COM,   YOU,    //  |X|O
            //                       -+-+-
            null,  null,  null}); //  | |

    board.nextPerfectMove();
    
    final Player[] expected = new Player[] {
        null,  COM,   YOU,    //  |X|O
        //                       -+-+-
        null,  COM,   YOU,    //  |X|O
        //                       -+-+-
        null,  COM,  null};   //  |X| 
    
    Assert.assertArrayEquals(expected, board.getBoard());
  }

  @Test
  public void testStartPlayer() {

    final Board board = new Board(YOU);

    board.nextMove(1);
    board.nextPerfectMove();
    board.print(false, true);
    
    board.nextMove(2);
    board.print(false, true);
    
    board.nextPerfectMove();
    board.print(false, true);
  }
  
  

}
