package de.hdm_stuttgart.mi.sd1.store;


import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.sd1.wc.TextFileStatistics;


@SuppressWarnings({"UnusedDeclaration", "javadoc"})
public class TestCountWords {

  @Test
  public void testNoWord() {
    Assert.assertEquals("Just white space", 0, TextFileStatistics.findNoOfWords(" \t"));
  }
  
  @Test
  public void testSingleWord() {
    final String s = "We're";
    Assert.assertEquals("text='" + s + "'", 1, TextFileStatistics.findNoOfWords(s));
  }
  
  @Test
  public void testTwoWords() {
    final String s = "We are";
    Assert.assertEquals("text='" + s + "'", 2, TextFileStatistics.findNoOfWords(s));
  }
  
  @Test
  public void testWordsWhiteHead() {
    final String s = "\t \tBegin_space";
    Assert.assertEquals("text='" + s + "'", 1, TextFileStatistics.findNoOfWords(s));
  }
  
  @Test
  public void testWordsWhiteTail() {
    final String s = "End_space \t ";
    Assert.assertEquals("text='" + s + "'", 1, TextFileStatistics.findNoOfWords(s));
  }
  
  @Test
  public void testWhiteMulti() {
    final String s = "    some\t\tinterspersed   \t  spaces \t\t ";
    Assert.assertEquals("text='" + s + "'", 3, TextFileStatistics.findNoOfWords(s));
  }
}
