package de.hdm_stuttgart.mi.sd1.fraction;

import static org.junit.Assert.*;

import org.junit.Test;

@SuppressWarnings({"UnusedDeclaration", "javadoc"})
public class FractionTest {

  /**
   * Sums and products of fractions
   */
  @Test
  public void testAddMultiplyReduce() {
    
    // Just constructor
    final Fraction twoThirds = new Fraction(4, 6);
    assertEquals(2, twoThirds.getNumerator());
    assertEquals(3, twoThirds.getDenominator());
    
    // Input
    final Fraction
      twoThird = new Fraction(5, 6),          // Construct a fraction object (2/3)
      threeSeven = new Fraction(2, 9);        // Construct a fraction object (3/7)

    // Computed results
    final Fraction
      sum = twoThird.add(threeSeven),         // (5/6) + (2/9)
      product = twoThird.mult(threeSeven);    // (2/3) * (3/7)

    assertTrue(sum.getNumerator() == 19 && sum.getDenominator() == 18);
    assertTrue(product.getNumerator() == 5 && product.getDenominator() == 27);
    
    final Fraction sum2 = new Fraction(5, 18).add(new Fraction(7, 12));
    assertTrue(sum2.getNumerator() == 31 && sum2.getDenominator() == 36);
    
    final Fraction product2 = new Fraction(5, 18).mult(new Fraction(12, 7));
    assertTrue(product2.getNumerator() == 10 && product2.getDenominator() == 21);
    
    
    

  }
}
