package de.hdm_stuttgart.mi.sda1.alignimg.handler;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class SaxErrorHandler implements ErrorHandler {
	private static final Logger log = LogManager.getLogger(SaxErrorHandler.class);

	public void warning(SAXParseException e) {
		log.warn("[Warning]" + getLocationString(e));
	  }
	  public void error(SAXParseException e) {
	    log.error("[Error]" + getLocationString(e));
	  }
	  public void fatalError(SAXParseException e) throws SAXException {
	    log.fatal("[Fatal Error]" + getLocationString(e));
	  }
	  private String getLocationString(SAXParseException e) {
	    return " line " + e.getLineNumber() +
	    ", column " + e.getColumnNumber()+ ":" +  e.getMessage();
	  }
}
