package de.hdm_stuttgart.mi;

import com.vaadin.ui.Button;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.Button.ClickListener;
import com.vaadin.ui.GridLayout;
import com.vaadin.ui.Label;
import com.vaadin.ui.PasswordField;
import com.vaadin.ui.TextField;
import com.vaadin.ui.Window;

/**
 * Handling user login requests.
 *
 */
public class LoginWindow extends Window {
   private static final long serialVersionUID = -6844250541237082478L;
   
   private final TextField loginField = new TextField(); 

   private final PasswordField passwordField = new PasswordField();

   /**
    * Handling user logins.
    */
   public LoginWindow() {
      super("Login"); // Set window caption
      center();

      // Some basic content for the window
      
      final GridLayout content = new GridLayout(2, 3);
      content.addComponent(new Label("Login"));
      content.addComponent(loginField);
      
      content.addComponent(new Label("Password"));
      content.addComponent(passwordField);
      
      content.setMargin(true);
      setContent(content);
      
      // Disable the close button
      setClosable(false);

      // Trivial logic for closing the sub-window
      final Button ok = new Button("OK");
      ok.addClickListener(event -> {
         close();
      });
      content.addComponent(ok);
  }
}