package de.hdm_stuttgart.mi.xmlstat;

import java.util.HashMap;
import java.util.Map;

import org.jdom2.Element;

public class ElementFrequency extends HashMap <String, Integer> {
      
   private static final long serialVersionUID = -3657626112837471743L;
   
   public void add (final String element, final Integer frequency) {
      if (containsKey(element)) {// Element already present in Map? --> Add frequency
         put (element, get(element) + frequency);
      } else {                      // Create new entry
         put (element, frequency);
      }
   }

   public void add (final Element element) {
      add(element.getName(), 1);
   }

   public void merge(Map<? extends String, ? extends Integer> map) {
      map.forEach((e, f) -> add(e, f));
   }
   
}
