package de.hdm_stuttgart.mi.xmlstat.test;

import static org.hamcrest.MatcherAssert.assertThat;

import java.io.IOException;

import org.hamcrest.Matchers;
import org.jdom2.JDOMException;
import org.jdom2.Namespace;
import org.junit.Test;

import com.google.common.collect.ImmutableMap;

import de.hdm_stuttgart.mi.xmlstat.ElementStatistics;

/**
 * Testing functional queries.
 */
@SuppressWarnings({"UnusedDeclaration"})
public class AggregationTest {


   /**
    * @throws IOException 
    * @throws JDOMException 
    * 
    */
   @Test
   public void xmlParseResult() throws JDOMException, IOException {

      final ElementStatistics elementLister = new ElementStatistics("x2html.xsl");

      assertThat(elementLister.elementsByNamespace,
            Matchers.equalTo( 
                  ImmutableMap.of (

                        Namespace.getNamespace("xsl", 
                              "http://www.w3.org/1999/XSL/Transform"),
                        new ImmutableMap.Builder<String, Integer>().
                        put("stylesheet", 1).
                        put("output", 1).
                        put("template", 2).
                        put("value-of", 1).
                        put("text", 2).
                        put("message", 1).build(),

                        Namespace.getNamespace("",
                              "http://www.w3.org/1999/xhtml"),
                        new ImmutableMap.Builder<String, Integer>().
                        put("head", 1).
                        put("p", 2).
                        put("meta", 1).
                        put("html", 1).
                        put("h2", 1).
                        put("title", 1).
                        put("body", 1).build(),

                        Namespace.getNamespace("",
                              "http://www.w3.org/2000/svg"),
                        ImmutableMap.of(
                              "svg", 1,
                              "circle", 1
                              )
                        ) 
                  ) 
            );
   }
}
