package de.hdm_stuttgart.mi.company;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import org.junit.Test;

import de.hdm_stuttgart.mi.company.model.Employee;
import de.hdm_stuttgart.mi.company.model.Project;
import de.hdm_stuttgart.mi.company.model.WorksFor;

/**
 * Assigning a user to a project and releasing the assignment
 * in a second transaction.
 *
 */
@SuppressWarnings({"UnusedDeclaration"})
public class DeleteProjectAssignmentTest {

   static final EntityManager em;

   static {
      final EntityManagerFactory emFactory =  Persistence.createEntityManagerFactory("create-drop");
      em = emFactory.createEntityManager();
   }

   @Test
   public void createDropAssignment() {

      Long jimId;
      {
         final EntityTransaction transaction = em.getTransaction();
         transaction.begin();

         final Project bridge = new Project("Bridge");

         final Employee jim = new Employee("Jom Bone", "bone@graveyard.com");

         new WorksFor(bridge, jim, 13);

         em.persist(bridge);
         transaction.commit();

         jimId = jim.getId();

      }

      {
         final EntityTransaction transaction = em.getTransaction();
         transaction.begin();

         final Employee jim = em.find(Employee.class, jimId);
         jim.getProjects().forEach(em::remove);
         
         transaction.commit();
      }
   }
}
