package de.hdm_stuttgart.mi.company;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.persistence.PersistenceException;

import org.hibernate.exception.ConstraintViolationException;
import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.company.model.Employee;
import de.hdm_stuttgart.mi.company.model.Project;
import de.hdm_stuttgart.mi.company.model.WorksFor;

@SuppressWarnings({"UnusedDeclaration"})
public class TestUniqueEmail {
	
    static final EntityManager em;

    static {
	    final EntityManagerFactory emFactory =  Persistence.createEntityManagerFactory("create-drop");
	    em = emFactory.createEntityManager();
	}

	@Test	
	public void insertData() {
		{
	          final EntityTransaction transaction = em.getTransaction();
	          transaction.begin();
	          
	          Throwable expectedProblem = null;
	          try {
	          em.persist(new Employee("Jom Bone", "bone@graveyard.com"));
	          em.persist(new Employee("Eve Bone", "bone@graveyard.com"));
	          
	          transaction.commit();
	          } catch (final PersistenceException ex) {
	        	  expectedProblem = ex.getCause();
		          transaction.rollback();
	          }
        	  Assert.assertTrue(expectedProblem instanceof ConstraintViolationException);
	    }
	}
}
