package jpaintro.university;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import jpaintro.university.model.Lecture;

public class CreateLectures {

   static final Logger log = LogManager.getLogger(CreateLectures.class);
   
	/**
	 * This refers to a corresponding element {@code <persistence-unit name = "strategy_drop-and-create" >} 
     * in META-INF/persistence.xml re-creating the relational database schema.
	 */
   static public final String PERSISTENCE_UNIT_DROP_CREATE = "strategy_drop-and-create";
    /**
     * @param args Unused
     */
    public static void main( String[] args ) {
       
       final EntityManagerFactory factory = Persistence.createEntityManagerFactory(PERSISTENCE_UNIT_DROP_CREATE);
       final EntityManager em = factory.createEntityManager();
       
       log.info("Begin transaction");
       em.getTransaction().begin();
       
       em.persist(new Lecture("Structured data and applications", 1111));
       em.persist(new Lecture("Software development", 2222));
       em.persist(new Lecture("Database systems", 3333));

       em.getTransaction().commit();
       log.info("Committed transaction");

       em.close();
     
       // See http://stackoverflow.com/questions/21645516/program-using-hibernate-does-not-terminate
       factory.close(); 
    }
}
