package rdbms2catalog;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import org.junit.Test;

import de.hdm_stuttgart.mi.sda1.sql2catalog.model.Description;
import de.hdm_stuttgart.mi.sda1.sql2catalog.model.Product;

@SuppressWarnings({"UnusedDeclaration"})
public class TestSchema {
	
    static final EntityManager em;

    static {
	    final EntityManagerFactory emFactory =  Persistence.createEntityManagerFactory("strategy_drop-and-create");
	    em = emFactory.createEntityManager();
	}

	@Test
	public void insertData() {
		{
	          final EntityTransaction transaction = em.getTransaction();
	          transaction.begin();
	          
	          final Product monkeyPickedTea = new Product(1, "Monkey Picked Tea", null);
	          monkeyPickedTea.getDescriptions().add(new Description("Picked by specially trained monkeys."));
	          monkeyPickedTea.getDescriptions().add(new Description("Rare wild Chinese tea."));
	          
	          final Product instantTent = new Product(2, "4-Person Instant Tent", 15);
	          instantTent.getDescriptions().add(new Description("Exclusive WeatherTec system."));
	          instantTent.getDescriptions().add(new Description("4-person, 1-compartment tent."));
	          instantTent.getDescriptions().add(new Description("Pre-attached tent poles."));
	          
	          em.persist(monkeyPickedTea);
	          em.persist(instantTent);
	          
	          transaction.commit();
	          em.close();
	          em.getEntityManagerFactory().close();
	    }
	}
}
