package de.hdm_stuttgart.mi.sda1.nocast.test;

import java.io.IOException;

import org.jdom2.JDOMException;
import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.sda1.nocast.DomXpath;

/**
 * Testing for image src values.
 */
@SuppressWarnings({"UnusedDeclaration"})
public class TestImg {

  /**
   * @throws JDOMException Corrupt content, failing to parse.
   * @throws IOException File access problem.
   */
  @SuppressWarnings("static-method")
  @Test
  public void testCsv() throws JDOMException, IOException {

    final DomXpath ao = new DomXpath();
    // The following HTML document is being searched
    // for <img> elements.

    Assert.assertEquals(
      "inline.gif, one.gif, http://www.hdm-stuttgart.de/favicon.ico",
      ao.process("src/main/resources/gallery.html").stream().
        map(a -> a.getAttributeValue("src")).
        reduce((a, b) -> a + ", " + b).orElse("empty list!")
    );
  }
}
