package de.hdm_stuttgart.mi.persistence;

/**
 * Communication between persistence and GUI layer
 *
 */
public interface PersistView {

      /**
       * Turn GUI into "connected" status
       */
      public abstract void setStatusConnected();

      /**
       * Turn GUI into "disconnected" status
       */
      public abstract void setStatusDisconnected();

      /**
       * Provide GUI status update.
       */
      public abstract void setDatasetInserted();

      /**
       * Provide GUI status update including informative message.
       * @param msg The informative message in question.
       */
      public abstract void guiInfo(String msg);

      /**
       * Provide GUI status update including error message.
       * @param msg The error message in question.
       */
      public abstract void guiError(String msg);
}
