package de.hdm_stuttgart.mi.sudoku.model;

import java.util.Optional;

import com.vaadin.data.Property;

public class IntegerBuffer implements Property<Integer>{

	private static final long serialVersionUID = 8674877251186847351L;

	final boolean isReadonly;
	Optional<Integer> value;
	
	public IntegerBuffer(final boolean isReadonly, final Integer value) {
		this.value = Optional.ofNullable(value);
		this.isReadonly = isReadonly;
	}
	
	@Override
	public void setValue(Integer value)
			throws ReadOnlyException {
		if (isReadonly) {
			throw new ReadOnlyException("Read only integer property value=" + value);
		} else {
			this.value = Optional.ofNullable(value);
		}
	}
	@Override
	public Integer getValue() {
		return value.orElse(null);
	}
	@Override
	public Class<? extends Integer> getType() {
		return Integer.class;
	}
	@Override
	public boolean isReadOnly() {
		return isReadonly;
	}
	@Override
	public void setReadOnly(boolean newStatus) {
	}
}
