package com.restfully.shop.helper;

import java.lang.annotation.Annotation;

import javax.ws.rs.core.MediaType;
import javax.xml.bind.Marshaller;
import javax.xml.bind.PropertyException;

import org.jboss.resteasy.annotations.DecorateTypes;
import org.jboss.resteasy.spi.interception.DecoratorProcessor;

@DecorateTypes({ "text/*+xml", "application/*+xml" })
public class PrettyPrintProcessor implements
      DecoratorProcessor<Marshaller, PrettyPrint> {

   public Marshaller decorate(Marshaller target, PrettyPrint annotation, Class type,
         Annotation[] annotations, MediaType mediaType) {
      try {
         target.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
      } catch (PropertyException e) {
         System.err.println("Unable to activate XML pretty-printing ");
      }
      return target;
   }

}
