package de.hdm_stuttgart.mi.sda2.jpa.billing.domain;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

@Entity
public class Customer {

   @Id @GeneratedValue(strategy=GenerationType.IDENTITY)
   Long id;
   
   @Column(nullable=false)
   String name;
   
   @OneToMany(mappedBy="customer", cascade= CascadeType.ALL)
   List<BillingDetail> billings = new ArrayList<BillingDetail>();
   
   protected Customer() {}
   
   public Customer(final String name) {
      setName(name);
   }

   public String getName() {
      return name;
   }

   public void setName(String name) {
      this.name = name;
   }

   public Long getId() {
      return id;
   }
   
   public void addBilling(final BillingDetail billing) {
      billings.add(billing);
      billing.setCustomer(this);
   }

   public List<BillingDetail> getBillings() {
      return billings;
   }
   
}
