package de.hdm_stuttgart.mi.sda2.jpa.cd.domain;

import static javax.persistence.CascadeType.PERSIST;
import static javax.persistence.CascadeType.REMOVE;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;

@Entity  @Table(name = "Lecture")
public class Lecture {
   @Id
   @GeneratedValue(strategy=GenerationType.IDENTITY)
   Long  id;
   
   @Column(nullable=false)
   String title;
   
   @Column(unique=true, nullable=false)
   int no;
   
   @OneToMany(mappedBy="lecture", cascade={PERSIST, REMOVE})
   Set<StudentLecture> students = new HashSet<StudentLecture>();
   
   protected Lecture() {}
   
   public Long getId() {
      return id;
   }
   
   public Set<StudentLecture> getStudents() {
      return students;
   }

   public void setStudents(Set<StudentLecture> students) {
      this.students = students;
   }

   public Lecture(final String title, final int no) {
      setTitle(title);
      setNo(no);
   }

   public String getTitle() {
      return title;
   }

   public void setTitle(String title) {
      this.title = title;
   }

   public int getNo() {
      return no;
   }

   public void setNo(int no) {
      this.no = no;
   }

   
   
}
