package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.sd1.aufgabe1.Helper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.DisableOnDebug;
import org.junit.rules.TestRule;
import org.junit.rules.Timeout;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.Marking;


@SuppressWarnings({"javadoc"})
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class TestHelper extends ExaminationTestDefaults {

  @Rule // Kill test if tests last longer than 1000 milliseconds unless in debugging mode
  public final TestRule timeout = new DisableOnDebug(Timeout.millis(1000));

  /**
   * Tests zu {@link Helper#klartextName(int)}
   */
  @Test
  @Marking(points=3)
  public void test_100_klartext() {
    Assert.assertEquals("sieben", Helper.klartextName(7));
  }

  @Test
  @Marking(points=3)
  public void test_120_klartext() {
    Assert.assertEquals("null", Helper.klartextName(0));
  }

  @Test
  @Marking(points=3)
  public void test_130_klartextNegativ() {
    Assert.assertEquals("Uuups, keine Regel für den Wert -1", Helper.klartextName(-1));
    Assert.assertEquals("Uuups, keine Regel für den Wert 13", Helper.klartextName(13));
  }

  /**
   * Tests zu {@link Helper#getProduktBetrag(int, int)}
   */
  @Test
  @Marking(points=8)
  public void test_145_produktbetrag() {
    Assert.assertEquals(10, Helper.getProduktBetrag(2, 5));
    Assert.assertEquals(110, Helper.getProduktBetrag(2, -55));
    Assert.assertEquals(120, Helper.getProduktBetrag(-40, 3));
    Assert.assertEquals(21, Helper.getProduktBetrag(-3, -7));
  }

  /**
   * Tests zu {@link Helper#getQuadrant(double)}
   */
  @Test
  @Marking(points=8)
  public void test_160_quadrant() {

    for (int i = 0; i < 90; i++) {
      Assert.assertEquals(1, Helper.getQuadrant(i));
    }

    for (int i = 90; i < 180; i++) {
      Assert.assertEquals(2, Helper.getQuadrant(i));
    }

    for (int i = 180; i < 270; i++) {
      Assert.assertEquals(3, Helper.getQuadrant(i));
    }

    for (int i = 270; i < 360; i++) {
      Assert.assertEquals(4, Helper.getQuadrant(i));
    }
  }

  /**
   * Tests zu {@link Helper#getZeitangabe(long)}
   */
  @Test
  @Marking(points=8)
  public void test_180_zeitangabe() {
    Assert.assertEquals("0:0:31", Helper.getZeitangabe(31));
    Assert.assertEquals("0:2:5", Helper.getZeitangabe(125));
    Assert.assertEquals("0:5:1", Helper.getZeitangabe(301));
    Assert.assertEquals("0:10:42", Helper.getZeitangabe(642));
    Assert.assertEquals("2:0:41", Helper.getZeitangabe(7241));
  }
}