package de.hdm_stuttgart.mi.sda2.hellojpa;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import de.hdm_stuttgart.mi.sda2.hellojpa.model.Airline;

public class CreateEntity {

   static final Logger log = LogManager.getLogger(CreateEntity.class);
   
   // This requires a corresponding entry <persistence-unit name="entitytemplatePU"> 
   // in META-INF/persistence.xml
   static public final String PERSISTENCE_UNIT_NAME = "entitytemplatePU";
    /**
     * @param args Unused
     */
    public static void main( String[] args ) {
       
       final EntityManagerFactory factory = Persistence.createEntityManagerFactory(PERSISTENCE_UNIT_NAME);
       final EntityManager em = factory.createEntityManager();
       
       log.info("Begin transaction");
       em.getTransaction().begin();
       final Airline lh = new Airline("Lufthansa", "DLH");
       
       em.persist(lh);
       em.getTransaction().commit();
       log.info("Committed transaction");

       em.close();
     
       // See http://stackoverflow.com/questions/21645516/program-using-hibernate-does-not-terminate
       factory.close(); 
    }
}
