#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
package ${package};

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import de.hdm_stuttgart.mi.sd1.model.Airline;

public class CreateAirline {

  static private final Logger log = LogManager.getLogger(CreateAirline.class);

  /**
   * This refers to a corresponding element <persistence-unit name = "strategy_drop-and-create" >
   * in META-INF/persistence.xml re-creating the relational database schema.
   */
  static final String PERSISTENCE_UNIT_NAME = "strategy_drop-and-create";

  static private final EntityManagerFactory factory = Persistence.createEntityManagerFactory(PERSISTENCE_UNIT_NAME);
  static private final EntityManager entityManager = factory.createEntityManager();
  /**
   * @param args Unused
   */
  public static void main( String[] args ) {


    log.info("Begin transaction");
    entityManager.getTransaction().begin();
    {
      entityManager.persist(new Airline("Lufthansa", "DLH"));
      entityManager.persist(new Airline("Los Cedros Aviación", "LSC"));
      entityManager.persist(new Airline("LATAM Argentina", "DSM"));
    }
    entityManager.getTransaction().commit();
    log.info("Committed transaction");

    entityManager.close();

    // See http://stackoverflow.com/questions/21645516/program-using-hibernate-does-not-terminate
    factory.close();
  }
}