#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
package ${package};

import com.mysema.query.jpa.impl.JPAQuery;
import de.hdm_stuttgart.mi.sd1.model.QAirline;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class DslSearchByIcao {
  static private final Logger log = LogManager.getLogger(DslSearchByIcao.class);

  /**
   * This refers to a corresponding element <persistence-unit name = "strategy_none" >
   * in META-INF/persistence.xml preserving the relational database schema.
   */
  static private final String PERSISTENCE_UNIT_NAME = "strategy_none";
  static private final EntityManagerFactory factory = Persistence.createEntityManagerFactory(PERSISTENCE_UNIT_NAME);
  static private final EntityManager entityManager = factory.createEntityManager();

  /**
   * @param args Unused
   */
  public static void main(String[] args) {

    log.info("QueryDSL search for Airline instances having icaoCode starting with 'D'");

    final QAirline qAirline = QAirline.airline;

    new JPAQuery(entityManager).
            from(qAirline).
            where(qAirline.icaoCode.like("D%")).
            list(qAirline).
            stream().
            map(s -> "like 'D%': Read »" + s + "«").
            forEach(System.out::println);

    // See http://stackoverflow.com/questions/21645516/program-using-hibernate-does-not-terminate
    factory.close();
  }
}