#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
package ${package};

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class JPQLSearchByIcao {
  static private final Logger log = LogManager.getLogger(JPQLSearchByIcao.class);

  /**
   * This refers to a corresponding element <persistence-unit name = "strategy_none" >
   * in META-INF/persistence.xml preserving the relational database schema.
   */
  static private final String PERSISTENCE_UNIT_NAME = "strategy_none";

  static private final EntityManagerFactory factory = Persistence.createEntityManagerFactory(PERSISTENCE_UNIT_NAME);
  static private final EntityManager entityManager = factory.createEntityManager();

  /**
   * @param args Unused
   */
  public static void main( String[] args ) {

    log.info("JPQL search for Airline instances having icaoCode starting with 'D'");

    // Eclipse users note: The subsequent line of code requires "mvn generate-sources" or equivalent
    // triggering the metamodel generator. You may want to right click on your project root choosing
    //
    // "Run As" --> "Maven generate-sources".
    //
    // This step is being required whenever changes to your model classes in de.hdm_stuttgart.mi.sd1.model happen.

    entityManager.
            createQuery("from Airline as a WHERE a.icaoCode like 'D%'").
            getResultList().
            stream().
            map(s -> "like 'D%': Read »" + s + "«").
            forEach(System.out::println);

    factory.close();
  }
}