package de.hdm_stuttgart.mi.exam.unitmarking.xml;

import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.helpers.DefaultHandler;

import java.util.List;
import java.util.Vector;
import java.util.stream.Collectors;

public class WellformedCheckHandler extends DefaultHandler {

    private List<SAXParseException> problems = new Vector<>();

    @Override
    public void warning(SAXParseException e) throws SAXException {
        problems.add(e);
    }

    @Override
    public void error(SAXParseException e) throws SAXException {
        problems.add(e);
    }

    @Override
    public void fatalError(SAXParseException e) throws SAXException {
        problems.add(e);
    }

    public String formatErrorMessages() {
        return problems.stream().map(s -> "line=" + s.getLineNumber() +
                ", column=" + s.getColumnNumber() + ":\n    " + s.getMessage()).
                collect(Collectors.joining("\n  "));
    }
    public void clear() {
        problems.clear();
    }
}