jQuery.fn.extend({

    toggleVisibilityState: function() {
        var ATT_TOGGLE_VALUES = [
        // attribute,  closed state                                      , open state
            ['value', '+',                                                 '-'],
            ['title', 'open solution (Did you try hard enough yourself?)', 'Close solution']
        ];
        var nextIndex;
        switch(this.attr(ATT_TOGGLE_VALUES[0][0])) { // First attribute defines reference
            case ATT_TOGGLE_VALUES[0][1]:
                nextIndex = 2; break;
            default:
                nextIndex = 1; break;
        }
        for (var r in ATT_TOGGLE_VALUES) {
            this.attr(ATT_TOGGLE_VALUES[r][0], ATT_TOGGLE_VALUES[r][nextIndex]);
        }
    }
});

function initBbPost(index, bbForumElement) {
    var postingsUrl = "https://bb.mi.hdm-stuttgart.de/api/topic/" + bbForumElement.getAttribute("data-tid");

    $.ajax({
        type: 'GET',
        url: postingsUrl,
        dataType: "json",
        success: function (data) {
            var postcount = data.postcount - 1;
            var p = bbForumElement.getElementsByTagName("p")[0];
            var a = p.getElementsByTagName("a")[0];
            var text;
            if (0 == postcount) {
                text = "Create comment";
                a.setAttribute("style", "color: red");
            } else {
                text = "Read comments (" + postcount + ((1 == postcount) ? " posting" : " postings") + ")";
                a.setAttribute("style", "color: green");
            }
            a.innerHTML = text;
        }
    });
}

$(document).ready(
    function () {
	$(".bbForum").each(initBbPost);
        $(".hideSolution").next().toggle(0); // Show or hide first following sibling
        $(".hideSolution").toggleVisibilityState(); // Initialization

        $(".hideSolution").click(
            function () {
                $(this).toggleVisibilityState();
                $(this).next().slideToggle(); // Show or hide first following sibling
            }
        );
    }
);
