drop table if exists EmployeeProject, Project, Employee, Department; 

CREATE TABLE Department(  
   id BIGINT PRIMARY KEY 
  ,number INTEGER NOT NULL UNIQUE
  ,name CHAR(20) NOT NULL UNIQUE
);

CREATE TABLE Employee (
   id BIGINT PRIMARY KEY
  ,number INTEGER NOT NULL UNIQUE
  ,name CHAR(20) NOT NULL
  ,surname CHAR(20) NOT NULL
  ,department BIGINT NOT NULL REFERENCES Department    
  ,telephone CHAR(4) NOT NULL
  ,fax CHAR(4) 
);

CREATE TABLE Project (
   id BIGINT PRIMARY KEY
  ,number INTEGER NOT NULL UNIQUE
  ,name CHAR(20) NOT NULL UNIQUE
  ,status SMALLINT NOT NULL
  ,CHECK (status IN (1,2,3,3)) -- planned, active, on hold, finished --
);

CREATE TABLE EmployeeProject (
   employee BIGINT NOT NULL REFERENCES Employee
  ,project BIGINT NOT NULL REFERENCES Project
  ,PRIMARY KEY(employee, project)
  ,weeklyHours INTEGER NOT NULL
)
