package component.address;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 * Persisting {@link User} instances having component E-Mail Addresses
 *
 */
public class PersistUser {
   /**
    * @param args not used.
    */
   public static void main(String[] args) {
      
      final EntityManagerFactory factory = Persistence.createEntityManagerFactory("componentAddressPU");
      final EntityManager em = factory.createEntityManager();

      em.getTransaction().begin();
      {
         final User u = new User(123, "goik", "Martin Goik");
         u.setHomeAddress(new Address("144 Kings Highway", "S.W. Dover", "DE 19901"));
         u.setWorkAddress(new Address("22 Baker St", "Morton", "PA 19070"));
         em.persist(u);
      }
      em.getTransaction().commit();

      em.close();
      factory.close();
   }
}