package component.email;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 * Persisting {@link User} instances having component E-Mail Addresses
 *
 */
public class PersistUser {

   /**
    * @param args not used.
    */
   public static void main(String[] args) {
      final EntityManagerFactory factory = Persistence.createEntityManagerFactory("componentEmailPU");
      final EntityManager em = factory.createEntityManager();

      em.getTransaction().begin();
      {
         final User u = new User(123, "goik", "Martin Goik");
         u.setEmailAddress(new Email("goik@hdm-stuttgart.de"));
         em.persist(u);
      }
      em.getTransaction().commit();

      em.close();
      factory.close();
   }
}