package entity.company3;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 * Persisting {@link Employee} possibly along with
 * personal assigned laptops.
 */
public class Persist {
   /**
    * @param args not used.
    */
   public static void main(String[] args) {
      final EntityManagerFactory factory = Persistence.createEntityManagerFactory("entityCompany3PU");
      final EntityManager em = factory.createEntityManager();

      em.getTransaction().begin();
      {
         final Employee  martin = new Employee(123, "Martin Goik"),
               eve = new Employee(140, "Eve Blix");

         final Laptop superCoolGadget = new Laptop(2213);
         eve.setLaptop(superCoolGadget);
         // Now only save the employee transients,
         // superCoolGadget will be saved automatically due to
         // CascadeType.ALL 
         em.persist(martin);
         em.persist(eve);

      }
      em.getTransaction().commit();

      em.close();
      factory.close();
   }
}