package entity.company6;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import entity.company6.model.Employee;
import entity.company6.model.Laptop;

public class Persist {
   public static void main(String[] args) {
      final EntityManagerFactory factory = Persistence.createEntityManagerFactory("entityCompany6PU");
      final EntityManager em = factory.createEntityManager();

      final Employee  martin = new Employee(123, "Martin Goik"),
            eve = new Employee(140, "Eve Blix");

      final Laptop superCoolGadget = new Laptop(2213),
            g2 = new Laptop(2214),
            g3 = new Laptop(2215); // Not being referenced later

      martin.setLaptop(g2);
      eve.setLaptop(superCoolGadget);

      em.getTransaction().begin();
      {
         // Now only save the employee transients,
         // superCoolGadget will be saved automatically due to
         // CascadeType.ALL 
         em.persist(martin);
         em.persist(eve);
         em.persist(g3);
      }
      em.getTransaction().commit();

      em.close();
      factory.close();
   }
}