package entity.company7.model;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;



/**
 * 
 *         {@link Employee} instances
 * 
 */
@Entity
@Table(uniqueConstraints={@UniqueConstraint(columnNames={"staffNumber"})})
public class Employee {

  @Id
  @GeneratedValue(strategy=GenerationType.IDENTITY)
  public Long getId() {return id;}
  protected void setId(Long id) {this.id = id;}
  private Long id;

  public int getStaffNumber() { return staffNumber;}
  public void setStaffNumber(int staffNumber) { this.staffNumber = staffNumber;}
  int staffNumber = Integer.MIN_VALUE;

  public String getCname() { return cname;}
  public void setCname(String cname) { this.cname = cname;}
  private String cname; // Common name

  @ManyToMany
  public Set<Project> getProjects() { return projects;}
  protected void setProjects(Set<Project> projects) { this.projects = projects;}
  public void addProject(final Project project) {
     getProjects().add(project);
     project.getCollaborators().add(this);
  }
  public void removeProject(final Project project) {
     getProjects().remove(project);
     project.getCollaborators().remove(this);
  }
  
  private Set<Project> projects = new HashSet<Project>();
  
  protected Employee(){}

  public Employee(final int staffNumber, final String cname) {
    setStaffNumber(staffNumber);
    setCname(cname);
  }
  @Override
  public boolean equals(Object other) {
    if (this == other) {
      return true;
    } else if (other instanceof Employee) {
      return getStaffNumber() == ((Employee) other).getStaffNumber();
    } else {
      return false;
    }
  }
  @Override
  public int hashCode() { return getStaffNumber();}
}