package hibintro.v1;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 * Retrieval of a single {@link User} object from a database.
 *
 */
public class GetSingleUser {

  /**
   * Retrieving a single {@link User} instance by means
   * of its primary key value "goik".
   * @param args unused
   */
  public static void main(String[] args) {
     final EntityManagerFactory factory = Persistence.createEntityManagerFactory("hibintroV1PU");
     final EntityManager em = factory.createEntityManager();

     em.getTransaction().begin();
     {
        final User u = em.find(User.class, "goik");
        if (null == u ) {
          System.out.println("No such user 'goik'");
        } else {
          System.out.println("Found user '" + u.getCname() + "'");
        }
     }
     em.getTransaction().commit();

     em.close();
     factory.close();
  }
}