package hibintro.v8;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;

/**
 *         {@link User} instances with 
 *         renaming of database table and attributes.
 */
@Entity
@Table(name="Person")
public class User {

  int uidNumber;
  @Id
  @Column(name="numericUid")
  public int getUidNumber() {
    return uidNumber;
  }
  public void setUidNumber(int uidNumber) { this.uidNumber = uidNumber; }

  String uid;

  /**
   * @return The user's unique login name e.g. "goik"
   */
  @Column(nullable=false)
  public String getUid() { return uid; }
  /**
   * @param uid
   *          See {@link #getUid()}.
   */
  public void setUid(String uid) { this.uid = uid; }

  String cname;

  /**
   * @return The user's common name e.g. "Martin Goik"
   */
  @Column(nullable = false, name="fullName")
  public String getCname() { return cname;  }
  /**
   * @param cname
   *          See {@link #getCname()}.
   */
  public void setCname(String cname) { this.cname = cname; }

  /**
   * Hibernate/JPA require a default constructor
   */
  protected User() {}
  /**
   * @param uidNumber See {@link #getUidNumber()}.
   * @param uid See {@link #getUid()}.
   * @param cname See {@link #getCname()}.
   */
  public User(int uidNumber, String uid, String cname) {
    setUidNumber(uidNumber);
    setUid(uid);
    setCname(cname);
  }
}