package inherit.joined.v1;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

/**
 * Retrieval of all {@link CreditCard} objects from a database.
 */
public class RetrieveAll {

  /**
   * @param args unused
   */
  public static void main(String[] args) {
     final EntityManagerFactory factory = Persistence.createEntityManagerFactory("inheritJoinedV1PU");
     final EntityManager em = factory.createEntityManager();

     em.getTransaction().begin();
     {
        final TypedQuery<BillingDetails> searchBilling = em.createQuery("from BillingDetails", BillingDetails.class);

        for (final BillingDetails c: searchBilling.getResultList()) {
          System.out.println(c);
        }
     }
     em.getTransaction().commit();

     em.close();
     factory.close();
  }
}