package inherit.v3;

import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.Transient;

@Entity
@DiscriminatorValue(value = "1")
public class Circle extends Figure {

   double radius;
   /**
    * @return The circle's radius
    */
   public double getRadius() {return radius;}
   public void setRadius(double radius) {this.radius = radius;}
   
   @Override
   public String toString() {
      return super.toString() + ", radius=" + getRadius();
   }
   
   @Transient
   public double getArea() {
      return Math.PI * getRadius() * getRadius();
   }
   public Circle(){super();}
   
   public Circle(final double xCoord, final double yCoord, final double radius) {
      super(xCoord, yCoord);
      setRadius(radius);
   }
}
