package inherit.v3;

import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.Transient;

@Entity
@DiscriminatorValue(value = "2")
public class Rectangle extends Figure {

   double width;
   public double getWidth() {return width;}
   public void setWidth(double width) {this.width = width;}
   
   double height;
   public double getHeight() {return height;}
   public void setHeight(double height) {this.height = height;}
   
   @Transient
   public double getArea() {
      return getWidth() * getHeight();
   }
   
   public String toString() {
      return super.toString() + ", width=" + getWidth() +
            ", height=" + getHeight();
   }

   protected Rectangle() {super();}
   public Rectangle(final double xCoord, final double yCoord, final double width, final double height){
      super(xCoord, yCoord);
      setWidth(width);
      setHeight(height);
   }
}
