<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
  
  <xsl:output
    doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN"
    doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" 
    method="xml" indent="yes"/>
  
  <xsl:template match="/book">
    <xsl:variable name="pageTitle" select="title"/>
    <html>
      <head>
        <title><xsl:value-of select="$pageTitle"/></title>
      </head>
      <body>
        <h1><xsl:value-of select="$pageTitle"/></h1>
        <xsl:apply-templates select="chapter"/>
      </body>
    </html>
  </xsl:template>
  
  <xsl:template match="chapter[@id]">
    <h2 id="{@id}"><xsl:value-of select="title"/></h2>
    <xsl:apply-templates select="para"/>
  </xsl:template>

  <xsl:template match="chapter">
    <h2><xsl:value-of select="title"/></h2>
    <xsl:apply-templates select="para"/>
  </xsl:template>
  
  <xsl:template match="para">
    <!-- The '*' matches emph, internlink and externlink elements -->
    <p><xsl:apply-templates select="text()|*"/></p>
  </xsl:template>
  
  <xsl:template match="emph">
    <em><xsl:value-of select="."/></em>
  </xsl:template>
  
  <xsl:template match="externlink">
    <a href="{@href}"><xsl:value-of select="."/></a>
  </xsl:template>
  
  <xsl:template match="internlink">
    <a href="#{@ref}"><xsl:value-of select="."/></a>
  </xsl:template>
  
</xsl:stylesheet>