package sax;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

import sax.stat.v2.MyErrorHandler;

/** Driver class */
public class ReadAttrib {
  
  /** @param argv unused
   *  @throws Exception Access problem or invalid content */
  public static void main(String argv[]) throws Exception{
    final ReadAttrib rAtt = new ReadAttrib();
    rAtt.parse("Input/Sax/catalog.xml");
  }
  /** Set up parser and error handler
   * @throws SAXException Parsing may fail.
   * @throws ParserConfigurationException Unable to instantiate parser.
   */
  public ReadAttrib()
   throws SAXException, ParserConfigurationException{
      final SAXParserFactory saxPf = SAXParserFactory.newInstance();
      final SAXParser saxParser = saxPf.newSAXParser();
      xmlReader = saxParser.getXMLReader();
      xmlReader.setContentHandler(eventHandler);
      xmlReader.setErrorHandler(errorHandler);
  }
  /** Initiate parsing
   * @param uri The resource to be parsed
   * @throws IOException Access related problems
   * @throws SAXException Parsing may fail
   */
  public void parse(final String uri) 
    throws IOException, SAXException{
    xmlReader.parse(uri);
  }
  private final XMLReader xmlReader;
  private final AttribEventHandler eventHandler = new AttribEventHandler();
  private final MyErrorHandler errorHandler = new MyErrorHandler();
}