package sax.rdbms;

import java.io.IOException;

import javax.xml.parsers.*;

import org.xml.sax.*;

import sax.stat.v2.MyErrorHandler;

/**Catalogs and database content */
public class XmlRdbms {
  
   private final XMLReader xmlReader;
   private final HtmlEventHandler htmlEh = new HtmlEventHandler();
   private final MyErrorHandler errorHandler = new MyErrorHandler();

  /** @param argv unused
   *  @throws Exception File access problem or corrupt content.
   *  
   */
  public static void main(String argv[]) throws Exception {
    final XmlRdbms val = new XmlRdbms();
    val.parse("Input/Sax/catalog.xml");
  }
  /** Setup for document processing
   * @throws SAXException Parsing may fail.
   * @throws ParserConfigurationException Unable to instantiate parser.
   * */
  public XmlRdbms()
   throws SAXException, ParserConfigurationException{
      final SAXParserFactory saxPf = SAXParserFactory.newInstance();
      final SAXParser saxParser = saxPf.newSAXParser();
      xmlReader = saxParser.getXMLReader();
      xmlReader.setContentHandler(htmlEh);
      xmlReader.setErrorHandler(errorHandler);
  }
  /** Start the conversion
   * @param uri The resource to be parsed
   * @throws IOException Access related problems
   * @throws SAXException Parsing may fail
   */
  public void parse(final String uri) 
    throws IOException, SAXException{
    xmlReader.parse(uri);
  }
}